var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-996487F1-62CD-4055-A601-99697BC74CD2\">\n\
      <meta name=\"indexterm\" content=\"error: checking\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Error checking</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-996487F1-62CD-4055-A601-99697BC74CD2\"></a><div class=\"head\">\n\
            <h1>Error checking</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F148A\"></a> In the examples presented so far you have not been prompted to do much error checking.\n\
            This is usually fine for examples, but when producing a production plug-in you really\n\
            want to check for errors. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F148C\"></a>Most methods take an optional final argument, which is a pointer to an <span class=\"char_link\"><a href=\"#!/url=./files/API_Important_plugin_features.htm#WS17956D7ADBC6E736-3269E342117AE332002-7FFB\">MStatus</a></span> variable into which the status return value is put. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F148D\"></a>If you replace the argument parsing code with the following fragment in the helix\n\
            example, the example will be checking for, and handling, most possible errors. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
// Parse the arguments.\n\
for ( i = 0; i &lt; args.length(); i++ )\n\
    if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>( \"-p\" ) == args.asString( i, &amp;stat )\n\
        &amp;&amp; MS::kSuccess == stat )\n\
    {\n\
        double tmp = args.asDouble( ++i, &amp;stat );\n\
        // argument can be retrieved as a double\n\
        if ( MS::kSuccess == stat )\n\
            pitch = tmp;\n\
    }\n\
    else if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>( \"-r\" ) == args.asString( i, &amp;stat )\n\
        &amp;&amp; MS::kSuccess == stat )\n\
    {\n\
        double tmp = args.asDouble( ++i, &amp;stat );\n\
        // argument can be retrieved as a double\n\
        if ( MS::kSuccess == stat )\n\
            radius = tmp;\n\
    }\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F148E\"></a>The addition of<span class=\"code\" translate=\"no\"> &amp;stat</span> to the asString() and asDouble() methods allows you to check if the casting operation\n\
            succeeds. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F148F\"></a>For example, <span class=\"code\" translate=\"no\">args.asString(i, &amp;stat)</span> could return<span class=\"code\" translate=\"no\"> MS::kFailure</span> if the index is greater than the number of arguments, \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1490\"></a>or \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F1491\"></a> <span class=\"code\" translate=\"no\">args.asDouble(++i, &amp;stat)</span> could fail if the argument could not be converted to a double. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";