var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-977A1ED5-ABF2-4F86-A045-B386AF17DD2E\">\n\
      <meta name=\"description\" content=\"This page describes how to work with simple, static attributes and plugs.\">\n\
      <meta name=\"indexterm\" content=\"attributes\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Attributes and plugs</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-977A1ED5-ABF2-4F86-A045-B386AF17DD2E\"></a><div class=\"head\">\n\
            <h1>Attributes and plugs</h1>\n\
         </div>\n\
         <p class=\"blurb\">This page describes how to work with simple, static attributes and plugs. </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBCD\"></a> A node by itself without any means to affect it is not very useful. Modification of\n\
            a node is done through attributes and plugs. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBCF\"></a>The attributes of a node define a data interface for the node to the rest of the graph.\n\
            The only data that nodes pass to one another during evaluation comes and goes through\n\
            this interface. They indicate what type of data can be accepted, what the name for\n\
            that data will be (in a long form, or a short form), whether the data can be made\n\
            into a list, and how the data is allowed to move in and out of the node. Types of\n\
            data include simple data types such as integer and floating point values, and more\n\
            complex data types such as points, whole polygonal meshes, and NURBS surfaces. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBD0\"></a>Plugs are constructs which contain the data for a given attribute. All data access\n\
            for the attribute is done through the plug. The attribute itself only defines the\n\
            data type and name for the attribute. Plugs also are the ports for making connections\n\
            between nodes. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBD1\"></a>Attribute names must be unique across the entire node hierarchy, that is, across all\n\
            derived and parent classes, but can be reused between unrelated nodes. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBD2\"></a>Attributes may have a default value assigned to them. This will be the value that\n\
            a plug on that attribute will have if its value has not been set. For example, a numeric\n\
            attribute always has a default value of zero, though this can be changed when creating\n\
            the attribute. Any of the typed attributes will have a default value equal to the\n\
            default value of the data type they accept—numeric data defaults to zero, matrix data\n\
            defaults to the identity matrix, etc. \n\
         </p>\n\
         <p><a name=\"GUID-FF284E83-D87F-44FD-9DBA-A572725F7AC3\"></a>There are two main things you have to do in order to set up a static attribute: \n\
         </p><a name=\"UL_B17D3E1F4A2A4FA089F8FCA2CD347C39\"></a><ul>\n\
            <li>Declare a static <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> class member for the attribute in your node class. Initialize them to null values.\n\
               \n\
            </li>\n\
            <li>Set up the attribute in your implementation of <span class=\"code\" translate=\"no\">MPxNode::initialize()</span>, and add it to your node. To do this, you use one of the classes that derives from\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute</a></span>, depending on what kind of data value your attribute will store. \n\
               <p><a name=\"GUID-DF613927-06A2-409A-9415-9C14AEDB19D9\"></a>For example, to use attributes that store simple numeric values, you would use the\n\
                  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a></span> class. See <span class=\"char_link\"><a href=\"#!/url=./files/Dependency_graph_plugins_The_basics.htm\">A basic dependency node example</a></span>. \n\
               </p> \n\
               <p><a name=\"GUID-191C83DF-E67F-414F-B484-2F92B0A3C798\"></a>To store more complex data types, you set them up using other attribute classes like\n\
                  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTypedAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTypedAttribute</a></span>. See <span class=\"char_link\"><a href=\"#!/url=./files/Dependency_graph_plugins_A_more_complex_example.htm\">A more complex dependency graph example</a></span>. \n\
               </p> \n\
            </li>\n\
         </ul>\n\
         <div class=\"section\"><a name=\"SECTION_4FC25FEB590B494BA38292D789D08963\"></a> \n\
            <h2><a name=\"GUID-8836665B-7731-4157-AD9A-9F7AA8646272\"></a>Attributes in the Maya UI\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FBD3\"></a>By default, Maya will automatically arrange the attributes of a node in the attribute\n\
               editor. If you desire a special arrangement of the attributes of your node, you can\n\
               write an attribute editor template for the node. This is a MEL file on your <span class=\"code\" translate=\"no\">MAYA_SCRIPT_PATH</span>, whose name is of the form <span class=\"code\" translate=\"no\">AE{nodeName}Template.mel</span>, that contains a MEL procedure with the name <span class=\"code\" translate=\"no\">AE{nodeName}Template</span>. This procedure contains <em class=\"mild\">editorTemplate</em> commands that instruct the attribute editor how to alter the default layout for the\n\
               attributes in the node. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";