var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-052EC6C3-BFF1-42E3-B4A5-1725700E3428\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Geometry remapping for hardware rendering</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-052EC6C3-BFF1-42E3-B4A5-1725700E3428\"></a><div class=\"head\">\n\
            <h1>Geometry remapping for hardware rendering</h1>\n\
         </div><a name=\"FIG_256AF5EEDEE14F98ADC6CBF285DF61D5\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-18F963A9-A2D7-4CA7-B4B1-EDBC323666BF-low.png\"></div>\n\
         <p>The following information focuses on the remapping of geometry data that can occur:\n\
            \n\
            	 \n\
         </p><a name=\"UL_112B2AEAC64D4E1481250CA87D11A632\"></a><ul>\n\
            <li> \n\
               <p>From the point of creation of polygonal meshes, either internally or via the \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> API interface, \n\
                  		  \n\
               </p> \n\
            </li>\n\
            <li> \n\
               <p>To the point where geometry is provided for hardware rendering. \n\
                  		  \n\
               </p> \n\
            </li>\n\
         </ul>\n\
         <p>The main goal is to describe how the vertex data provided at render time can be mapped\n\
            back to the original geometry. In particular, we consider the case where the requirement\n\
            is to remap data back to a series of original quadrilateral (quad) faces. Such is\n\
            the case for Ptex texture mapping. \n\
            	 \n\
         </p>\n\
         <p>To start, basic triangulation logic and uniform subdivision logic used for the \n\
            		<span class=\"MenuCascade\">Smooth Mesh Preview</span> display option is described. This information can aid in understanding the algorithm\n\
            performed by custom remapping which matches what is performed internally by Maya.\n\
            This information pertains to the logic in Maya 2016 and is applicable for both VP1\n\
            (Legacy Default Viewport) and VP2 (Viewport 2.0). \n\
            	 \n\
         </p>\n\
         <p>Secondly, access to remapping data at shading time is examined. The main advantage\n\
            of using remapped data is that the plug-in does not need to keep up with the complexity\n\
            of internal logic changes within Maya. The provided data has already undergone all\n\
            internal data manipulation in the same manner as other per-vertex attributes (such\n\
            as positions and normals). \n\
            	 \n\
         </p>\n\
         <p>The internal remapping logic is current as of Maya 2016 and is subject to change over\n\
            time. Reverse-engineering this logic is not recommended. \n\
            		In addition, the index remapping logic used for triangulation and sculpting performance,\n\
            as well as adaptive subdivision, add additional complexity and non-determinism for\n\
            VP2. \n\
            	 \n\
         </p>\n\
         <p>Access to equivalent remapping data for both VP1 and VP2 hardware shader interfaces\n\
            are also examined. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_21CA9A2AEC6D4E7281AE27AFB257A05C\"></a> \n\
            <h2><a name=\"GUID-34B0C51E-7A3B-4816-825E-DAE8B4542FD4\"></a>Remapping logic\n\
            </h2> \n\
            <div class=\"section\"><a name=\"SECTION_71C5DEF3E3D6416A814FB2BDB1465239\"></a> \n\
               <h3><a name=\"GUID-4659E771-47AF-49B1-9D55-604976B73EFE\"></a>Triangulation\n\
               </h3> \n\
               <p>Triangulation occurs in order to produce geometric indexing, which can be used when\n\
                  hardware rendering. The choice of which local vertex indices are used for splitting\n\
                  is determined by the triangulation logic. Knowledge of which split is used can aid\n\
                  in determining the mapping of a pair of triangles back to the original quad. \n\
                  		  \n\
               </p> \n\
               <p>By default, the logic used for polygonal shapes attempt to provide the \n\
                  			 <em class=\"mild\">best shaped</em> triangles. However, for remapping, the overriding goal is to obtain predictability\n\
                  as to how the splitting occurs. As such, the \n\
                  			 <span class=\"code\" translate=\"no\">quadSplit</span> attribute on mesh shapes can be set to improve predictability. \n\
                  		  \n\
               </p> \n\
               <p>The \n\
                  			 <span class=\"code\" translate=\"no\">quadSplit</span> option determines how quads are split into two triangles. If \n\
                  			 <em class=\"strong\"><span class=\"MenuCascade\">Left</span></em> is selected, then the new edge will be between the 2nd and 4th vertex, while \n\
                  			 <em class=\"strong\"><span class=\"MenuCascade\">Right</span></em> splits between the 1st and 4th vertex. \n\
                  			 <em class=\"strong\"><span class=\"MenuCascade\">Best Shape</span></em> attempts to pick the best split based on the shape of the quad, but this may change\n\
                  as the shape deforms across an animation. \n\
                  		  \n\
               </p> \n\
               <p>Thus, selecting either a Left or Right split will provide greater predictability.\n\
                  \n\
                  		  \n\
               </p> <a name=\"FIG_DC8971A649C54042ADA456094BB7BEBE\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-1F5F3626-6FF2-43C6-A1CA-1A3725142F0A-low.png\"></div> \n\
               <p>A Left split is shown in the images below. The dotted line shows where the split occurred.\n\
                  \n\
                  		  \n\
               </p> <a name=\"FIG_4D3702BF232A4F82AC2176F6DED618E7\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-DBE85B52-1026-44C2-AE23-C66477149C1D-low.png\"></div> \n\
               <p>If Best Shape is still desired, the reference logic for a quad is given below. The\n\
                  general algorithm handles general N-sided polygons, which may have holes, but is not\n\
                  included here. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">v0 = quad vertex 0\n\
v1 = quad vertex 1\n\
v2 = quad vertex 2\n\
v3 = quad vertex 3\n\
\n\
dist02 = distance between v0 and v2\n\
dist13 = distance between v1 and v3\n\
\n\
// Use small tolerance so exact squares triangulate consistently\n\
// one way rather than randomly due to rounding errors\n\
fudgeFactor = 0.999f\n\
canSplit = false\n\
split02 = false\n\
\n\
if( dist02 &lt; fudgeFactor*dist13 )\n\
{\n\
    n1 = normal of triangle 1, 2, 0\n\
    n2 = normal of triangle 2, 3, 0\n\
\n\
    if( angle between n1 and n2 is less than 90 degrees )\n\
    {\n\
        if( area of triangle1 &lt; 7 * area of triangle2 &amp;&amp;\n\
                    area of triangle2 &lt; 7 * area of triangle1 )\n\
        {\n\
            canSplit = true\n\
            split02 = true\n\
        } \n\
    }\n\
}\n\
else\n\
{\n\
    n1 = normal of triangle 0, 1, 3\n\
    n2 = normal of triangle 3, 1, 2\n\
\n\
    if( angle between n1 and n2 is less than 90 degrees )\n\
    {\n\
        if( area of triangle1 &lt; 7 * area of triangle2 &amp;&amp;\n\
                area of triangle2 &lt; 7 * area of triangle1 )\n\
        {\n\
            canSplit = true\n\
            split02 = false\n\
        } \n\
    }\n\
}\n\
\n\
if( canSplit )\n\
{\n\
    if( split02 )\n\
    {\n\
        set triangle 1 = 1,2,0\n\
        set triangle 2 = 0,2,3\n\
    }\n\
    else\n\
    { \n\
        set triangle 1 = 0,1,3\n\
        set triangle 2 = 3,1,2\n\
    }\n\
}\n\
else \n\
{\n\
   // Fall back to general triangulation algorithm    \n\
}</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_7DD796980C374FB0BF1DF2AE1F8D491D\"></a> \n\
               <h3><a name=\"GUID-C6EDF277-31D3-4069-BE33-4FA44EA364A7\"></a>MFnMesh considerations\n\
               </h3> \n\
               <p>The triangulation option on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> differs from those used internally and will always use a \n\
                  			 <em class=\"strong\">best shape</em> option. \n\
                  		  \n\
               </p> \n\
               <p>Remapping of indexing does not occur if the triangulation method on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> is not called, and the interfaces that provide data for storage on an \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> do not reshuffle any data passed in. If the triangulation method is not called, then\n\
                  the internal triangulation logic will take into account the \n\
                  			 <span class=\"code\" translate=\"no\">quadSplit</span> option. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_6DF809991BBB448A837B58C288C3ECFC\"></a> \n\
               <h3><a name=\"GUID-EF80F283-469A-4F38-97B4-5A567615E1D2\"></a>Smooth Mesh Preview considerations\n\
               </h3> \n\
               <p>It should be noted that, for \n\
                  			 <span class=\"MenuCascade\">Smooth Mesh Preview</span>, the \n\
                  			 <span class=\"code\" translate=\"no\">quadSplit</span> option is not used. \n\
                  		  \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AE28B47B1F2C4E39911099F6B4738ED0\"></a> \n\
            <h2><a name=\"GUID-C588B26D-E03E-488C-AB86-65C0CCB13EBE\"></a>Subdivision\n\
            </h2> \n\
            <p>The \n\
               		  <span class=\"MenuCascade\">Smooth Mesh Preview</span> option on polygonal shapes is another occasion where the original geometric data\n\
               may be remapped. As the geometry provided at rendering will have a smoothing algorithm\n\
               applied to produce a new set of geometry, additional logic is required to not only\n\
               handle indexing on existing vertices, but also new vertices that have been introduced\n\
               along with the corresponding new indexing. \n\
               		\n\
            </p> \n\
            <p>The following sections discuss the mapping logic (rules) for uniform subdivision when\n\
               using either OpenSubiv (OSD) or legacy Catmull-Clark logic. In particular, the \n\
               		  <em class=\"strong\">winding order</em> of vertices and faces and the \n\
               		  <em class=\"strong\">local parametric (UV)</em> location of new vertices is covered. The local parameterization can be remapped to\n\
               texture coordinates as required for texture map lookups. \n\
               		\n\
            </p> \n\
            <p>We refer to the original geometry as the \n\
               		  <em class=\"strong\">base</em> geometry. For example, an original face is a base face. \n\
               		\n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_DF1D8AB6AF2642DCAD9BA7D59505D219\"></a> \n\
               <h3><a name=\"GUID-58F9559B-38E6-4192-97B7-40B278747D22\"></a>Maya uniform OpenSubdiv subdivision\n\
               </h3> <a name=\"FIG_726D8914013A46819BF822DB7F836E62\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-0DD8E79D-9041-44CC-B345-BF31903D32ED-low.png\"></div> \n\
               <p>The figure above shows a base face (left image) and the start and winding order of\n\
                  the subdivided faces and vertices when 1 level of subdivision is applied (center and\n\
                  right images). \n\
                  		  \n\
               </p> \n\
               <p>Levels closer to the base level are considered as being \n\
                  			 <em class=\"mild\">higher</em>. The subdivided face ordering is thus shown to be consistent with higher levels.\n\
                  The start face is in the bottom-left corner which aligns to the start vertex on the\n\
                  base face. Similarly, the vertices on the subdivided faces also start from the bottom-left\n\
                  corner. The winding order is always counter-clockwise (CCW). \n\
                  		  \n\
               </p> \n\
               <p>Assuming the origin of the local UV is located at vertex 0 of the base face, it is\n\
                  possible to deduce the local UV\'s of the vertices on the subdivided faces. \n\
                  		  \n\
               </p> \n\
               <p>The following is the some sample code to determine the local parametric value. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the UV of the bottom-left corner of the subdivided face.\n\
//\n\
// - subdFaceIndex, the index of subdivided face within a base face.\n\
// - subdLevel, the Catmull-Clark subdivision level \n\
//\n\
// such that: \n\
//\n\
// - subdLevel &gt;= 1 \n\
// - 0 &lt;= subdFaceIndex &lt;= 4^subdLevel\n\
// - the UV value is encoded as an integer within [0, 2^subdLevel].\n\
//\n\
getSubFaceUV(subdFaceIndex, subdLevel) \n\
{\n\
    uv = (0,0);\n\
\n\
    count = pow(4, subdLevel - 1);\n\
    ofs = pow(2, subdLevel - 1);\n\
\n\
    // Iteratively find the index of a parent face in each subdivision level,\n\
    // and offset the UV accordingly.\n\
    faceIndex = subdFaceIndex;\n\
    while (count &gt; 0) {        \n\
        start = faceIndex / count;\n\
        switch (start) {\n\
            case 0:                  break;\n\
            case 1: uv += (ofs,0);   break;\n\
            case 2: uv += (ofs,ofs); break;\n\
            case 3: uv += (0,ofs);   break;\n\
        }\n\
\n\
        faceIndex %= count;\n\
        ofs &gt;&gt;= 1;\n\
        count &gt;&gt;= 2;\n\
    }    \n\
    return uv;\n\
}\n\
\n\
// Get the UV of the vertex on the subdivided face.\n\
//\n\
// - subdFaceStartUV: the UV of the bottom-left corner of the subd face.\n\
// - subdVertexIndex: vertex index on the subdivided face, 0~3.\n\
//\n\
getSubVertexUV(subdFaceStartUV, subdVertexIndex) {\n\
    uv = (0,0);\n\
    switch (subdVertexIndex) {\n\
        case 0:              break;\n\
        case 1: uv += (1,0); break;\n\
        case 2: uv += (1,1); break;\n\
        case 3: uv += (0,1); break;    \n\
    }\n\
    return subdFaceStartUV + uv;\n\
}\n\
\n\
subdFaceStartUV = getSubFaceUV(subdFaceIndex, subdLevel);\n\
subdVertexUV = getSubVertexUV (subdFaceStartUV, subdVertexIndex);\n\
subdVertexUV /= pow(2, subdLevel);</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_BF6FFAE2B98A4D2B82AB1DEF17E01102\"></a> \n\
               <h3><a name=\"GUID-3F9B3649-D2B9-4BD3-82F4-63F075031143\"></a>Maya legacy Catmull-Clark subdivision\n\
               </h3> \n\
               <p>The logic for Maya legacy subdivision is a little more complex. \n\
                  		  \n\
               </p> <a name=\"FIG_139D418AC69047F0AA2965CBBABE8D02\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-60E9F181-796F-4767-A8CB-7E8A733A87C9-low.png\"></div> \n\
               <p>The figure above shows a base face (left) and the start and winding order of the subdivided\n\
                  faces and vertices when 1 level of subdivision is applied (center and right images).\n\
                  The start of the subdivided face aligns to the second (index = 1) vertex on the base\n\
                  face, while the starting vertex continues to shift accordingly, based on the subdivided\n\
                  face number. \n\
                  		  \n\
               </p> \n\
               <p>The following is the sample code. The sections of the code that differ from that of\n\
                  the OpenSubdiv algorithm is \n\
                  			 <em class=\"strong\">highlighted in bold</em>. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the UV of the bottom-left corner of the subdivided face.\n\
// \n\
// - subdFaceIndex, the index of subdivided face within a base face\n\
// - subdLevel, the Catmull-Clark subdivision level\n\
// \n\
// such that:\n\
//\n\
// - subdLevel &gt;= 1. \n\
// - 0 &lt;= subdFaceIndex &lt;= 4^subdLevel,\n\
// - the uv is encoded as integer within [0, 2^subdLevel].\n\
//\n\
getSubFaceUV(subdFaceIndex, subdLevel) {\n\
    uv = (0,0);    \n\
    start = 1;\n\
\n\
    count = pow(4, subdLevel - 1);\n\
    ofs = pow(2, subdLevel - 1);\n\
\n\
    // Iteratively find the index of parent face in each subdivision level,\n\
    // and offset the UV\'s accordingly.\n\
    faceIndex = subdFaceIndex;\n\
    while (count &gt; 0) {\n\
        <em class=\"codeEmphasisStrong\">// Unlike OSD subdivided topology, the start position of the child face \n\
        // is related to that of the parent face.\n\
        start = (start + faceIndex / count) % 4;</em>\n\
        switch (start) {\n\
            case 0:                  break;\n\
            case 1: uv += (ofs,0);   break;\n\
            case 2: uv += (ofs,ofs); break;\n\
            case 3: uv += (0,ofs);   break;\n\
        }\n\
\n\
        faceIndex %= count;\n\
        ofs &gt;&gt;= 1;\n\
        count &gt;&gt;= 2;\n\
    }\n\
    // The start position of the face is also returned.\n\
    <em class=\"codeEmphasisStrong\">return (uv, start);</em>\n\
}\n\
\n\
// Get the uv of the vertex on the subdivided face.\n\
//\n\
// - subdFaceStartUV, the UV of the bottom-left corner of the subdivided face.\n\
// - subdVertexIndex, vertex index on the subdivided face, 0~3.\n\
//\n\
getSubVertexUV(subFaceStartIndex, subFaceStartUV, subdVertexIndex) {\n\
    uv = (0,0);\n\
    <em class=\"codeEmphasisStrong\">// Unlike OSD subdivided topology, the start of the vertex relies on \n\
    // the start position of the face.\n\
    start = (subdFaceIndex - 1 + 4) % 4;</em>\n\
    switch ((start + subdVertexIndex) % 4) {\n\
        case 0:              break;\n\
        case 1: uv += (1,0); break;\n\
        case 2: uv += (1,1); break;\n\
        case 3: uv += (0,1); break;    \n\
    }\n\
    return subFaceStartUV + uv;\n\
}\n\
\n\
(subdFaceStartUV, start) = getSubFaceUV(subdFaceIndex, subdLevel);\n\
subdVertexUV = getSubVertexUV(start, subdFaceStartUV, subdVertexIndex);\n\
subdVertexUV /= pow(2, subdLevel);</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_B77F5AB9A57D44D2B3F0368BD78B7BE4\"></a> \n\
            <h2><a name=\"GUID-AB914C01-036B-4898-BBF4-F0F089FB8A33\"></a>Data remapping interfaces\n\
            </h2> \n\
            <p>For both Viewport 1 and Viewport 2.0, it is possible to retrieve remapped data by\n\
               specifying the requirement for the following data buffers via the appropriate hardware\n\
               shader interface. The following remapping data is currently available: \n\
               		\n\
            </p> <a name=\"UL_CDDAFC0D78C640848C94363F9B45F5F4\"></a><ul>\n\
               <li> \n\
                  <p>Vertex ids \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>Face ids \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>Per face local parameterization \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
            <p>The data can be used directly instead of computing the remapping at draw time using\n\
               the logic previously described. In addition, the data is cached and is only updated\n\
               as required when topological operations affect the polygonal shape. \n\
               		\n\
            </p> \n\
            <p>When an object’s geometry has not been smoothed for display: \n\
               		\n\
            </p> <a name=\"UL_131EB504118A426CB4ECA810E0B394C8\"></a><ul>\n\
               <li>The original face ids are returned in ascending order. \n\
                  		  \n\
               </li>\n\
               <li> \n\
                  <p>The original vertex ids are returned per face. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>The local parameterization degenerates to a unit square per face. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
            <p>When smoothing for display is enabled: \n\
               		\n\
            </p> <a name=\"UL_B784F484E3F941E1AF9B614A71EAF679\"></a><ul>\n\
               <li> \n\
                  <p>The base face ids are returned. The ordering is per subdivided faces in ascending\n\
                     order. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>The subdivided vertex ids are returned. The ordering is per subdivided faces in ascending\n\
                     order. As vertices may be generated for display purposes, there will be vertex ids\n\
                     that do not correspond to any vertex on the base mesh. If desired, these vertices\n\
                     can be matched with the vertex ids on the smooth mesh geometry extracted via the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> interface. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>The local parameterization maps each vertex to a unit square on the base face. The\n\
                     ordering is per subdivided face in ascending order. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
            <p>The data buffers returned for VP1 and VP2 have consistent data and ordering, as long\n\
               as the request for VP2 buffers includes a request for unshared data. Note that VP1\n\
               always returns unshared data. \n\
               		\n\
            </p> \n\
            <p>If additional data is required for remapping, this can be done by adding additional\n\
               per-vertex streams at the object level (such as color sets). \n\
               		\n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_9FDD62F2CC1740C8BC027023B02687CA\"></a> \n\
               <h3><a name=\"GUID-F892C530-4BDC-4EB0-A834-AD3E5AD929A7\"></a>Viewport 1: MPxHwShaderNode access\n\
               </h3> \n\
               <p>To request additional information, the following API methods can be overridden by\n\
                  classes that derive from \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hw_shader_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode</a></span>: \n\
                  		  \n\
               </p> <a name=\"UL_31BFFE6A9E9C465890F1A3EB2464449B\"></a><ul>\n\
                  <li>Vertex ids can be requested by overriding the method: \n\
                     				<a name=\"UL_C07416DD36D84216924E8A4A2C89CA34\"></a><ul>\n\
                        <li><span class=\"code\" translate=\"no\">bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideVertexIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#ac8569dc0556726f17320788563f034c6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::provideVertexIDs()</a></span> \n\
                        </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li>Face ids can be requested by overriding the method: \n\
                     				<a name=\"UL_15DBE5844BCF4BD2A08ADEB7E1DC9F51\"></a><ul>\n\
                        <li><span class=\"code\" translate=\"no\">bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideFaceIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#afa61effad561b9564e161fe930bd038c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::provideFaceIDs()</a></span> \n\
                        </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li>Local parameterization can be requested by overriding the method: \n\
                     				<a name=\"UL_B4F3039148AC4BEDB167E13818B0999E\"></a><ul>\n\
                        <li><span class=\"code\" translate=\"no\">bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideLocalUVCoord()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a276892ea9def000206de6522deccc137&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::provideLocalUVCoord()</a></span> \n\
                        </li>\n\
                     </ul> \n\
                  </li>\n\
               </ul> \n\
               <p>The information is cached and returned as CPU data buffers via the \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::geometry()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#acd6773ef64b27965c09ed584830bf8f3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::geometry()</a></span> or \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::glGeometry()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a495a60eaa1df3815d5565e79e08c90ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::glGeometry()</a></span> methods. The signature for \n\
                  			 <span class=\"code\" translate=\"no\">glGeometry()</span> is: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::glGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a495a60eaa1df3815d5565e79e08c90ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxHwShaderNode::glGeometry</a>( const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a>&amp; shapePath,\n\
    int prim,\n\
    unsigned int writable,\n\
    int indexCount,\n\
    const unsigned int * indexArray,\n\
    int vertexCount,\n\
    const int * vertexIDs,\n\
    const float* vertexArray,\n\
    int normalCount,\n\
    floatArrayPtr normalArrays,\n\
    int colorCount,\n\
    floatArrayPtr colorArrays,\n\
    int texCoordCount,\n\
    floatArrayPtr texCoordArrays,\n\
    const int * faceIDs,\n\
    const float * localUVCoord)</pre></div> \n\
               <p> Sample code to obtain this data can found in the \n\
                  			 <em class=\"mild\">hwPhongShader</em> plug-in example. Below is a code sample from within the \n\
                  			 <span class=\"code\" translate=\"no\">glGeometry()</span> method implementation: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// Dump out vertexIDs\n\
if (vertexIDs)\n\
{\n\
    for (int i=0; i&lt;vertexCount; i++)\n\
    {\n\
        printf(\"%d\\n\", vertexIDs[i]);\n\
    }\n\
}\n\
\n\
// Dump out face IDs\n\
if (faceIDs)\n\
{\n\
    for (int i=0; i&lt;vertexCount; i++)\n\
    {\n\
        printf(\"%d\\n\", faceIDs[i]);\n\
    }\n\
}\n\
}\n\
\n\
// Dump out float pairs for the local parameterization (UV)\n\
if (localUVCoord)\n\
{\n\
    for (int i = 0; i &lt; vertexCount; i++)\n\
    {\n\
        printf(\"(%g, %g)\\n\", localUVCoord[i*2], localUVCoord[i*2 + 1]);\n\
    }\n\
}</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_9AF6D0D34ABC48F7895B0E3A58B809CA\"></a> \n\
               <h3><a name=\"GUID-B215F16A-656E-4C9C-8E18-99B8D0435AB8\"></a>Viewport 2.0: MPxShaderOverride Access\n\
               </h3> \n\
               <p>VP2 will not, by default, return completely unshared data. A new interface has been\n\
                  added to specify this requirement via: \n\
                  		  \n\
               </p> <a name=\"UL_CB3A038AA73C49FD96C071A14BE6C9FF\"></a><ul>\n\
                  <li> \n\
                     <p><span class=\"code\" translate=\"no\">bool MPxShaderOverride::requiresUnsharedGeometricSteams()</span> \n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
               <p>A plug-in can override this method to return true in order to force geometric streams\n\
                  to be expanded. \n\
                  		  \n\
               </p> \n\
               <p>To obtain the face ids, vertex ids or local parametrization, the following \n\
                  			 <em class=\"mild\">semantics</em> have been added (instead of a new interface on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span>): \n\
                  		  \n\
               </p> <a name=\"UL_91A6FF21756244BEA043054D66C1D4B4\"></a><ul>\n\
                  <li> \n\
                     <p>vertexid : When set will return a vertex id buffer \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p>faceid : When set will return a face id buffer \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p>localuvcoord : When set will return a local UV coordinate buffer \n\
                        				\n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
               <p>The following example code from the \n\
                  			 <em class=\"mild\">hwPhongShader</em> plug-in example specifies three extra streams within its \n\
                  			 <span class=\"code\" translate=\"no\">initialize()</span> method. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// Ask for vertex IDs\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> vertexIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
vertexIdDesc.setSemanticName(\"vertexid\");\n\
addGeometryRequirement(vertexIdDesc);\n\
\n\
// Ask for face IDs\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> faceIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
faceIdDesc.setSemanticName(\"faceid\");\n\
addGeometryRequirement(faceIdDesc);\n\
\n\
// Ask for local parameterization data\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> localUvCoordDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
faceIdDesc.setSemanticName(\"localuvcoord\");\n\
addGeometryRequirement(localUvCoordDesc);\n\
</pre></div> \n\
               <p>Sample extraction code (also from the same plug-in) is shown here: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">for (int vbIdx=0; vbIdx&lt;geometry-&gt;vertexBufferCount(); vbIdx++)\n\
{\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a>* vb = geometry-&gt;vertexBuffer(vbIdx);\n\
    if (!vb) continue;\n\
\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a>&amp; desc = vb-&gt;descriptor();\n\
    if (desc.dimension() != 1) continue;\n\
\n\
    // Check if semantic is for the streams we’re looking for.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> semanticName = desc.semanticName();\n\
\n\
    // Dump out local parameterization. Each pair of float values gives\n\
    // a local UV on the base face.\n\
    if (semanticName == \"localuvcoord\")\n\
    {\n\
        // Cancel constness to map buffer and dump data.\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a>* \n\
        nonConstVB = const_cast&lt;<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a>*&gt;(vb);\n\
    \n\
        const float *ptr = (const float*)nonConstVB-&gt;map();\n\
        for (unsigned int k = 0; k &lt; vb-&gt;vertexCount(); k++)\n\
        {\n\
            printf(\"%s[%d] = (%g, %g)\\n\", semanticName.asChar(), \n\
                k, ptr[2*k], ptr[2*k + 1]);\n\
        }\n\
        nonConstVB-&gt;unmap();\n\
    }\n\
\n\
    // Dump out vertex or face identifiers. If smoothed the vertex ids will be\n\
    // the smoothed ids, but the face ids are always the base face ids.\n\
    //\n\
    if (semanticName != \"vertexid\" &amp;&amp; semanticName != \"faceid\") continue;\n\
\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a>* nonConstVB = const_cast&lt;<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a>*&gt;(vb);\n\
    const float *ptr = (const float*)nonConstVB-&gt;map();\n\
    for (unsigned int k=0; k&lt;vb-&gt;vertexCount(); k++)\n\
    {\n\
        printf(\"%s[%d] = %f\\n\", semanticName.asChar(), k, ptr[k] );\n\
    }\n\
    nonConstVB-&gt;unmap();\n\
}</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_5FFB3FDB8E1A4179BC93CFA939E1B175\"></a> \n\
               <h3><a name=\"GUID-7E8939A5-6297-42CC-A7C9-2F4AB254A383\"></a>Viewport 2.0: MGeometryExtractor Access\n\
               </h3> <a name=\"FIG_53165B94B01144CCA2558432D1A7AC7F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-57E9DA6F-DB97-48FB-859F-5FA7A7471DF8-low.png\"></div> \n\
               <p>Viewport 2.0 also exposes the access of vertex ids, face ids and local parameterization\n\
                  via the \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometryExtractor</a></span> interface. To extract completely unshared geometric data from a DAG shape, \n\
                  			 <span class=\"code\" translate=\"no\">kPolyGeom_NotSharing</span> needs to be specified when constructing an \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometryExtractor</a></span> instance. \n\
                  		  \n\
               </p> \n\
               <p>Example code from the \n\
                  			 <em class=\"mild\">geometryReplicator</em> plug-in is shown here. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
MHWRender::MPolyGeomOptions options = <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::kPolyGeom_Normal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html#abed82baf7f470b522273a3e37c24c600a6f4996143f966bf5534e8dae77fb015d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::kPolyGeom_Normal</a>;\n\
if (requiresUnsharedGeometricStreams(requirements))\n\
{\n\
    options = options | <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::kPolyGeom_NotSharing\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html#abed82baf7f470b522273a3e37c24c600a891eaab0dc4731ae402710120a0aa503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::kPolyGeom_NotSharing</a>;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometryExtractor</a> extractor(requirements, fPath, options, &amp;status);</pre></div> \n\
               <p>The following code snippet illustrates how the \n\
                  			 <em class=\"mild\">geometryReplicator</em> plug-in determines whether unshared data is required, according to the geometry requirements.\n\
                  \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">bool requiresUnsharedGeometricStreams(const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometryRequirements</a>&amp; requirements)\n\
{\n\
    // Only when vertexid, faceid or localuvcoord is required do the unshared geometric\n\
    // streams need to be extracted\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptorList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptorList</a>&amp; descList = requirements.vertexRequirements();\n\
    for (int reqNum = 0; reqNum &lt; descList.length(); ++reqNum)\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> desc;\n\
        if (descList.getDescriptor(reqNum, desc) &amp;&amp;\n\
            desc.semantic() == <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTexture</a>)\n\
        {\n\
            const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> semanticName = desc.semanticName();\n\
            if (semanticName == \"vertexid\" ||\n\
                semanticName == \"faceid\" ||\n\
                semanticName == \"localuvcoord\")\n\
            {\n\
                    return true;\n\
            }\n\
        }\n\
    }\n\
    return false;\n\
}</pre></div> \n\
               <p>Similar to \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span>, there is no new interface on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometryExtractor</a></span> that requests vertex ids, face ids or local parameterization. Instead \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> should be specified with the following semantic names to populate these vertex buffers:\n\
                  \n\
                  		  \n\
               </p> <a name=\"UL_6AFA94DF75BF4F3FBB7EF2A986DA6689\"></a><ul>\n\
                  <li>“vertexid” : When set, will return a vertex id buffer \n\
                     			 \n\
                  </li>\n\
                  <li>“faceid” : When set, will return a face id buffer \n\
                     			 \n\
                  </li>\n\
                  <li>“localuvcoord” : When set, will return a local uv coordinate buffer \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
               <p>Although these semantic names are not specified directly in the \n\
                  			 <em class=\"mild\">geometryReplicator</em> plug-in, they will be included in the geometry requirements if a \n\
                  			 <em class=\"mild\">geometryReplicator</em> node is assigned a \n\
                  			 <em class=\"mild\">hwPhongShader</em>. The following example illustrates how to specify any of them explicitly. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// Request vertex IDs (or face IDs, local parameterization)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> vertexIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
vertexIdDesc.setSemanticName(\"vertexid\");\n\
\n\
// Create a vertex buffer via <a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a> interface, extract and fill the data.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBuffer</a> vertexBuffer = geometry.createVertexBuffer(vertexIdDesc);\n\
unsigned int vertexCount = extractor.vertexCount();\n\
float* data = (float*)vertexBuffer-&gt;acquire(vertexCount, true);\n\
if (data &amp;&amp; extractor.populateVertexBuffer(data, vertexCount, vertexIdDesc))\n\
{\n\
    vertexBuffer-&gt;commit(data);\n\
}</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_12C27BA9ABFB4A3AB254C29FE0AF6377\"></a> \n\
               <h3><a name=\"GUID-2FB90DF4-122F-4CD2-B7A1-71196A6C35A9\"></a>Accessing data via index buffers\n\
               </h3> \n\
               <p>Index buffers that are provided at render time can be used to access the data buffers\n\
                  on a per triangle basis. \n\
                  		  \n\
               </p> \n\
               <p>As VP1 has no consolidation, and vertices are unshared, every 3 indices reference\n\
                  a vertex id for a triangle in ascending face order. \n\
                  		  \n\
               </p> \n\
               <p>For VP2, consolidation may result in a set of sub-ranges in the index buffer. Each\n\
                  range delineates the data used for each object that was consolidated. To avoid ambiguous\n\
                  mapping, unshared data should always be requested. Refer to \n\
                  			 <span class=\"char_link\"><a href=\"#!/url=./files/GUID-63572033-5999-4865-822D-A803A8BED59E.htm#SECTION_F93F85CDC61C47B5974290CBD2DD2631\">Consolidation considerations</a></span> for more details on range handling. \n\
                  		  \n\
               </p> \n\
               <p>The \n\
                  			 <em class=\"mild\">hwPhongShader</em> plug-in includes sample code that demonstrates how to extract indexing information\n\
                  for both VP1 and VP2. For VP2, range handling sample debugging code is provided. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_6E2CEFA0F2274AB6903C954C26A95A61\"></a> \n\
               <h3><a name=\"GUID-C1796E3C-8D3E-464E-879B-E9C72C717FA9\"></a>Example 1: Unsmoothed quad\n\
               </h3> <a name=\"FIG_838DCA0A67534275B3737756471C257D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D6410011-C81A-4397-A225-DCDF6F9333B9-low.png\"></div> \n\
               <p>To examine the remapping that occurs, the \n\
                  			 <em class=\"mild\">hwPhongShader</em> plug-in which uses the API to extract additional data buffers is used for an example.\n\
                  In this case, an instance of that shader is assigned to a shape with a single quad\n\
                  as shown above. The base face id and base vertex ids are shown, as well as the start\n\
                  vertex (dot) and winding order (curved arrow). \n\
                  		  \n\
               </p> \n\
               <p>The render time buffers would look like this: \n\
                  		  \n\
               </p> <a name=\"TABLE_04D6F9C9985345AE9AF1750686627963\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id (CCW winding)</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Face id</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Local UV</em> \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_EE161E70ECB84236A5245CA4E07D8443\"></a> \n\
               <h3><a name=\"GUID-1304C714-C482-4A4E-BE20-F989FA6C762E\"></a>Example 2: Smoothed Level 1 Quad - OpenSubdiv Catmull-Clark \n\
               </h3> <a name=\"FIG_28D3A7BC35D34E97A2FD85DB71B47ADC\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-72FED596-1367-4C04-8B70-714F99211C7C-low.png\"></div> \n\
               <p>The topology shown above demonstrates one level of smoothing using OpenSubdiv. The\n\
                  start and winding order per sub-face and sub vertex is consistent for all levels with\n\
                  the base face. \n\
                  		  \n\
               </p> \n\
               <p>The data buffers would appear as follows. Note that: \n\
                  		  \n\
               </p> <a name=\"UL_69ED1ACAD66845FE88A31159B105BBA0\"></a><ul>\n\
                  <li> \n\
                     <p>The Sub-Face Id column is added to show its correlation to the topology shown above,\n\
                        but is not provided as a separate vertex buffer. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p> Vertex ids 6 to 8 are not part of the base mesh. \n\
                        				\n\
                     </p> \n\
                     <p>Vertex ids 4, 5, 6, 7, 8 are vertices introduced as part of smoothing. The base mesh\n\
                        has vertices 0, 1, 2, 3. The dotted lines show where the subdivision occurred due\n\
                        to the smoothing operation. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><em class=\"strong\">The local parameterization simply provides values to show the interpolation relative\n\
                           to the base vertices</em>, and is not related to the actual placement of the vertex within the base face. For\n\
                        example, if vertex 8 was actually positioned close to vertex 0, the local UV value\n\
                        would still be (0.5,0.5), such as in this geometry: \n\
                        				\n\
                     </p> <a name=\"FIG_4A9AC348AB89402B8E83340C899D8AB8\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-74265FA2-A0DA-4B97-AFC6-ADACD92EFE97-low.png\"></div> \n\
                  </li>\n\
               </ul> <a name=\"TABLE_05D22F9DF8D540DB9760C2C09A6C4085\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id (CCW)</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Face Id</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Sub-Face Id</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Local UV</em> \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
               <p>The provided index buffer can be used to access information per triangle. \n\
                  		  \n\
               </p> \n\
               <p>As noted, the triangle split may not match the value specified for the \n\
                  			 <span class=\"code\" translate=\"no\">quadSpit</span> attribute on the polygonal shape. If we are given this triangulation: \n\
                  		  \n\
               </p> <a name=\"FIG_4508BE7ABEC14269BCFDE314A71E2BB7\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-448A5417-F5BC-456F-BA98-3DA172E582E8-low.png\"></div> \n\
               <p>Then the index buffer would look something like this. \n\
                  		  \n\
               </p> <a name=\"TABLE_745F8390667F44798687D3E1ADB03C25\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Triangle number</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id</em> \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_BC3874D76F1B44A88F1D183E474A0406\"></a> \n\
               <h3><a name=\"GUID-0A1F1C59-275B-4E7F-8B6B-1E6C575367E1\"></a>Example 3: Smoothed Level 1 Quad – Legacy Catmull-Clark\n\
               </h3> <a name=\"FIG_E34F88B88304421481983DCEF219770B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-50C09AD4-5BAB-4109-B5F2-A83C949D4272-low.png\"></div> \n\
               <p>The topology above demonstrates one level of smoothing using the Legacy Catmull-Clark\n\
                  subdivision method. The shifting of the start of sub-faces and sub-vertices can be\n\
                  seen. \n\
                  		  \n\
               </p> \n\
               <p>The data buffers would be as follows. As in Example 2, the Sub-Face Id column is added\n\
                  to show its correlation to the topology shown above, and is not provided as a buffer.\n\
                  \n\
                  		  \n\
               </p> \n\
               <p>The shift in sub-face and sub-vertex start positions reflects what is shown in the\n\
                  diagram. \n\
                  		  \n\
               </p> <a name=\"TABLE_504668CEB57F4A3B9A688D28E16E8A20\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id (CCW)</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Face Id</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Sub-Face Id</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Local UV</em> \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 1) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (1, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> (0.5, 0.5) \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
               <p>Legacy Catmull-Clark has different indexing than OpenSubdiv Catmull-Clark, based on\n\
                  the fact that its start face and start vertices differ. Therefore, using the same\n\
                  example, the triangulation appears as follows: \n\
                  		  \n\
               </p> <a name=\"FIG_AC33B1DA083A40EDBB606DEFCC15B75F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-CED43D7B-ACB8-499E-87BF-5D944C8A5E42-low.png\"></div> \n\
               <p>The indexing would be as follows: \n\
                  		  \n\
               </p> <a name=\"TABLE_26D50AE7969D40C3B4D21A20E82369B1\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Triangle number</em> \n\
                        </th>\n\
                        <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id</em> \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 1 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 3 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 2 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 5 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 6 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 8 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 0 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> 7 \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\"> 4 \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_F6CBD46291BF492BBDC1EA483D64C567\"></a> \n\
               <h3><a name=\"GUID-0751FF1B-FF1B-45DD-AB0E-9F5A99EDAAD1\"></a>Example 4: Smoothed Level 2 Quad – Legacy Catmull-Clark\n\
               </h3> \n\
               <p>The following image shows a subdivision of level 2 using the Legacy Catmull-Clark\n\
                  method, and illustrates a repeat of the subdivision pattern. \n\
                  		  \n\
               </p> <a name=\"FIG_9A6FC270F0E8429398F6F5B46D9568E8\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-6C3EBEF8-1152-47EB-A514-0EC876BC4777-low.png\"></div> \n\
            </div> \n\
            <p>With the following data trace from the \n\
               		  <em class=\"mild\">hwPhongShader</em> plug-in: \n\
               		\n\
            </p> \n\
         </div><a name=\"TABLE_6DE2620F019648B892DF99AF1D0F12B5\"></a><div class=\"table-ruled\">\n\
            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
               <colgroup>\n\
                  <col>\n\
                  <col>\n\
                  <col>\n\
                  <col>\n\
               </colgroup>\n\
               <tr class=\"ruled-heading\">\n\
                  <th class=\"table-heading\"> <em class=\"strong\"> Vertex Id (CCW)</em> \n\
                  </th>\n\
                  <th class=\"table-heading\"> <em class=\"strong\"> Face Id</em> \n\
                  </th>\n\
                  <th class=\"table-heading\"> <em class=\"strong\"> Sub-Face Id</em> \n\
                  </th>\n\
                  <th class=\"table-heading\"> <em class=\"strong\"> Local UV</em> \n\
                  </th>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 1 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 21 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 1 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 1 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 18 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 1 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 21 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 1 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 18 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 2 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 2 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 17 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 2 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 21 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 2 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 17 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 3 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 3 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 3 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 21 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 3 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 3 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 16 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 22 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 16 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 19 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 22 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 19 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 18 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 22 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 18 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 6 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 1) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 22 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.75) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 2 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 23 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 20 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 23 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 20 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 19 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 23 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 10 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 19 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 7 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (1, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 23 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.75, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 24 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 12 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 9 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 4 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 17 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 24 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 13 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 17 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 8 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.5) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 20 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 24 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 14 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 20 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 5 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.5, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-odd-row\">\n\
                  <td class=\"table-body\"> 11 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
               <tr class=\"ruled-even-row\">\n\
                  <td class=\"table-body\"> 24 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 0 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> 15 \n\
                     				\n\
                  </td>\n\
                  <td class=\"table-body\"> (0.25, 0.25) \n\
                     				\n\
                  </td>\n\
               </tr>\n\
            </table>\n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";