var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-4B8DC200-C8A5-450B-BE37-553942215D14\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Multiple Draw APIs</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4B8DC200-C8A5-450B-BE37-553942215D14\"></a><div class=\"head\">\n\
            <h1> Multiple Draw APIs </h1>\n\
         </div>\n\
         <p><a name=\"GUID-4577E9EA-8F2E-401D-9AFF-D1453B603209\"></a>The API is presented in a draw API agnostic for the most part. If a plug-in is writing\n\
            for entry points which are draw API specific then it should return the API that it\n\
            is being used for. The interface \n\
            		<span class=\"code\" translate=\"no\">supportedDrawAPIs()</span> is provided for all relevant entry points. \n\
            	 \n\
         </p>\n\
         <p><a name=\"GUID-D6F69F3A-3DB1-4171-9234-B05AA7F40AAF\"></a>It is the responsibility of the plug-in to set up any dependent draw API libraries\n\
            or interfaces. The SDK ships with specific versions of libraries for each supported\n\
            draw API. Current dependent libraries are CgFx, DirectX11 and a pre-compiled DX11\n\
            effect runtime library. As the source code ships with the DirectX SDK, the pre-compiled\n\
            DX11 effect library can be recompiled by plug-in writers and linked explicitly to\n\
            their own plug-in. Current library versions are listed as part of the shipping resource\n\
            notes. \n\
            	 \n\
         </p>\n\
         <p><a name=\"GUID-75579150-A6A4-4C9E-81E4-BB1303FE82E7\"></a>Some notable draw API caveats are listed below. These are restrictions are imposed\n\
            by the draw API libraries rather than a restriction in the Maya API. \n\
            	 \n\
         </p><a name=\"UL_8208A1C6EE794A6BB696A25A0C4B30DB\"></a><ul>\n\
            <li>When using the texture or target manager provided, not all formats are available for\n\
               all draw APIs. Refer to externally published documentation provided with each API.\n\
               \n\
               		\n\
            </li>\n\
            <li>Textures accessed from the texture manager use the upper-left corner as the origin.\n\
               Shaders should be written with the appropriate texture coordinate to perform a vertical\n\
               flip as necessary. \n\
               		\n\
            </li>\n\
            <li>Cube map texture face orientation is draw API specific. \n\
               		\n\
            </li>\n\
            <li>Stock shaders provided by the shader manager hide the details of differences between\n\
               shading languages. When not using stock shaders, the plug-in writer will need to write\n\
               code which is specific to that shading language. For example, handling differences\n\
               in vector / matrix multiplication between Cg and HLSL. \n\
               		\n\
            </li>\n\
            <li>User-created shader fragments registered with \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFragmentManager</a></span> are not required to define implementations for both OpenGL (Cg) and DirectX (HLSL).\n\
               However, if both implementations are defined, it is up to the author to handle any\n\
               differences between the two (such as texture access or matrix math). In some cases,\n\
               this may even require completely different fragments to be written, requiring the\n\
               classes that use the fragments to choose the correct fragment for the currently active\n\
               device. \n\
               		\n\
            </li>\n\
            <li>It is quite possible that some geometry requirements specified from an \n\
               		  <span class=\"code\" translate=\"no\">MPxShaderNode</span> are not fulfilled. In this case the plug-in will need to handle this situation. In\n\
               particular, noting how DirectX is less tolerant to vertex stream mismatches than OpenGL.\n\
               \n\
               		\n\
            </li>\n\
         </ul>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";