var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Basic Viewport 2.0 pipeline sequencing</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023\"></a><div class=\"head\">\n\
            <h1>Basic Viewport 2.0 pipeline sequencing</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E43D8C53FA574BB4A95256E4AD335496\"></a> \n\
            <h2><a name=\"GUID-224D2202-ACB1-47A6-8697-4A4E7A38A151\"></a>Introduction\n\
            </h2> \n\
            <p><a name=\"GUID-C838BE80-D7CA-4A2D-A62B-3AA9D16467C7\"></a>This section covers the basic sequencing of the Viewport 2.0 pipeline when rendering\n\
               a 3d representation of the scene to the viewport or image on disk. It is within this\n\
               sequence where various render items or UI drawables are handled. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-4BA8579C-5248-458F-920D-525B0E4E6F08\"></a>The assumption is that render items and UI drawables have gone through the renderer’s\n\
               internal consolidation, filtering and categorization mechanism to produce lists of\n\
               render items or lists of UI drawables. An example would be a list of opaque shaded\n\
               render items. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-37777525-14B0-4F8A-8FBF-3A5F9E052198\"></a>Certain lists may be sorted based on a given criteria. For example, a transparent\n\
               render item list may be sorted by distance to the current camera, while material items\n\
               may be sorted by shader uniqueness (key). When unsorted, the ordering in the list\n\
               does not necessarily reflect the ordering that render items are stored on an override,\n\
               or any Maya scene object ordering. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-9C80D3A5-7EDD-41A4-B035-CC9BC10B9B0A\"></a>The finest granularity used to describe a sequence is called a logical \n\
               		  <em class=\"strong\">operation</em>, to match the nomenclature used for Viewport 2.0 render overrides (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderOverride</a></span>). Even for a complex internal render graph, the assumption is that it can be broken\n\
               down into a linear sequence of operations. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-7B381807-1FB7-4F76-9FA9-8C0FB194F000\"></a>At the highest level, a sequence is broken down into frames, where a \n\
               		  <em class=\"strong\">frame</em> performs rendering in order to produce the contents of an off-screen color and depth\n\
               output target. The targets that are used to present to an interactive viewport or\n\
               save to disk image are called \n\
               		  <em class=\"strong\">final</em> targets. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-C0F375DC-EE64-4A80-B9D2-FE5B19F0B525\"></a>Where applicable, an indication as to whether a \n\
               		  <em class=\"strong\">pass semantic</em> is used is shown in the description of the internal sequencing. Operations that specify\n\
               a unique pass semantic are denoted using the characters \n\
               		  <em class=\"strong\">(P)</em>. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-E463B313-BC38-4263-9FBA-A19B3204A039\"></a>Rendering for a frame is broken down into roughly three parts: \n\
               		  <em class=\"strong\">pre-scene</em> rendering, \n\
               		  <em class=\"strong\">scene</em> rendering, and \n\
               		  <em class=\"strong\">post-scene</em> rendering. The main conditional branching for UI items is dependant on whether post-effects\n\
               have been enabled. This generally entails UI items being moved to lists that draw\n\
               after post-effects have been applied. \n\
               		\n\
            </p> \n\
            <div><a name=\"GUID-7426F8F3-C487-4599-A7F2-0B24E0C38D86\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                  <p><a name=\"GUID-FBE5704F-7701-42BF-A9BB-8A32E3F0B7B6\"></a>The following is a snapshot of a typical frame render, and the actual sequencing may\n\
                     deviate from what is presented here depending on the render graph produced. Also,\n\
                     the categorizations of various items are a reflection of the current implementation\n\
                     and can also deviate if the implementation changes. \n\
                     		  \n\
                  </p> \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D414095EB8D448C086877AB7EAF9303E\"></a> \n\
            <h2><a name=\"GUID-01132528-1E7B-4DC2-9D0A-9EF36BE5A591\"></a>Pre-scene rendering\n\
            </h2> \n\
            <p><a name=\"GUID-868E2C5D-1C29-4C9D-908A-9C66DADB43D7\"></a>Within the pre-scene rendering phase, the basic operations include: \n\
               		\n\
            </p> <a name=\"UL_8FE6B5E7086C4E308A5693DC2C5194EB\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-61EFD6B7-6BA6-465C-85F9-595BE5F88C91\"></a>Shadow map update (See \n\
                     				<span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_7C920E165E9246D6A7D6EFAB03793EC2\">Shadow pass rendering</a></span> below.) \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-E68BA23E-A710-4A9D-8275-CE309750CBAA\"></a> Sort material render items \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-C7320BBD-154E-4C0E-9327-50B237395358\"></a> Clearing the color channel (background) for a color target \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-42C2DB0E-F997-4802-9F87-0807ADDAC4E0\"></a> If on-screen rendering desired: \n\
                     			 \n\
                  </p> <a name=\"UL_213A40E4505E49AA85A89F5DAFC969B2\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-E7116A0E-9A79-4773-A15A-83D1351E6DAF\"></a>Viewport pre render notification \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-A656DB19-D153-4197-8298-66882693951E\"></a>Pre-frame notification \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-5A575783-1FB9-4E23-972F-1AD30ECE3981\"></a>Pre-scene notification \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-2FFD0C49-06CD-4DA5-86B1-EC25ED28B93A\"></a>Optionally render the scene to produce the contents of a depth target: \n\
                     			 \n\
                  </p> <a name=\"UL_3E96B4925C734AFFB40DAD96DE11093B\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-969D7379-B76A-49CE-ABEE-31F6561E10E0\"></a>Opaque non-UI render items (for example, shaded triangles) (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-15EF593E-A941-40FE-B94E-C42BC78C8F30\"></a>Opaque UI render items (for example, wireframe) (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-4EC623AF-283F-4E51-A89D-729FBC170E3B\"></a>Semi-transparent bitmap render item (P). See \n\
                           					 <span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_3552E4104363428496513CED0696FAEA\">Particle rendering</a></span> for an example. \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-4B0D0EFB-E5C8-4B6E-A09D-8ADFD6792553\"></a>Render items that can act as \n\
                     				<em class=\"mild\">hold-outs</em> (P). Note that this is quite similar to a regular non-hold-out sequence. \n\
                     			 \n\
                  </p> <a name=\"UL_974D9F1478C14018B08C1B3196F75211\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-CC90180A-2F2D-4B4B-974C-5CC2A71688C4\"></a>Opaque non-UI render items (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-4C93EB1C-B6DA-4065-BAC0-A23C6BF6DDA6\"></a>Opaque UI items (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-D1CE5EE1-442D-474F-930E-3C8E99B15130\"></a>Transparency drawing (P). See \n\
                           					 <span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_62D62E880F5E4084A87DD0D0777D5264\">Transparency rendering</a></span>. \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9F03A9227F0046C38C0DA0317FE9A1D5\"></a> \n\
            <h2><a name=\"GUID-530B104F-9AD0-4590-838B-62E80179E6EE\"></a>Scene rendering\n\
            </h2> \n\
            <p><a name=\"GUID-D2AD5001-4375-40B5-8751-B06CFF578377\"></a><em class=\"mild\">Scene</em> rendering, which can also be thought of as representing the \n\
               		  <em class=\"mild\">beauty</em> pass, renders using the following operations: \n\
               		\n\
            </p> <a name=\"UL_FED2B617CD634F58B06E39C91B2B769F\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-0E9BD822-E703-4E32-8627-2B5894C3BFBC\"></a>When post effects are disabled: \n\
                     			 \n\
                  </p> <a name=\"UL_96E67EB00F4B4AE089EA47930B7FAA18\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-D87B4A16-F5B8-4809-9A5C-773EC743757E\"></a>Pre-scene opaque UI render items (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-8EF6E534-C6DF-41CC-AF13-FF8D321B6D92\"></a> Opaque non-UI render items (P) \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-C2D43843-E567-40AD-9D53-80DA2EBC8A8A\"></a>Opaque UI render items (P) \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-5F2DA895-7970-4B52-877F-918056475997\"></a> Semi-transparent bitmap render items (P). See \n\
                     				<span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_3552E4104363428496513CED0696FAEA\">Particle rendering</a></span> for an example. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-914A7A3A-3256-4214-9CF8-1741D2802307\"></a>Transparency drawing (P). See \n\
                     				<span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_62D62E880F5E4084A87DD0D0777D5264\">Transparency rendering</a></span>. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AA04B99C96F643AAB53D26CEA002960D\"></a> \n\
            <h2><a name=\"GUID-7A1C50A8-0BF3-4E7B-B8FA-7D1C35170595\"></a>Post-scene rendering\n\
            </h2> \n\
            <p><a name=\"GUID-13C73837-A2DD-4C3D-A05A-5B5721916076\"></a>Post-scene rendering includes operations for 2D post effects, and any additional UI\n\
               drawing that should not participate when any 2D post effect is enabled. By default,\n\
               certain items do not take part in post effects. Otherwise, the option to override\n\
               the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setExcludedFromPostEffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a634faadbe865d745bc8ed447efe671da&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem::setExcludedFromPostEffects()</a></span> method is available. \n\
               		\n\
            </p> <a name=\"UL_93269A6B2E2C417BAE0158916835D083\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-C3A98983-24AC-4DE3-A9FB-5B2EC3B16C3A\"></a>SSAO (screen space ambient occlusion) post effect \n\
                     			 \n\
                  </p> <a name=\"UL_D10D01841BD84D23AE03D386A11139D6\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-A2E662DF-DCAF-480A-81C1-6FD46FC50C64\"></a>Hold-out render items \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-D590F137-5DF9-48A7-A3B2-F8332092F063\"></a>Normal + Depth rendering pass (P) \n\
                           				  \n\
                        </p> <a name=\"UL_5F86AC6A462A4AE09F94B2EC77A29352\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-8736B54D-3A1B-4FA3-9E76-CD2A7704B924\"></a>Render items marked as participating in post effects. \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-4C875AA4-A1C0-43A0-ACA6-DCD793E7FE85\"></a>2D SSAO main algorithm \n\
                           				  \n\
                        </p> <a name=\"UL_36BD38A1F84645749C6DAAE88E4D261D\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-FA3EF22C-1A6B-49E1-A20B-52D167B3897C\"></a>Full screen quad rendering only \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-3D311948-C2BC-4A94-A8F0-9EB68C4EFA80\"></a> Motion blur post effect \n\
                     			 \n\
                  </p> <a name=\"UL_D2118DD598C04C7AA916FC074DF8A3F8\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-5D98E2F0-723D-4490-B361-2BA805949A2B\"></a>Motion vector pass \n\
                           				  \n\
                        </p> <a name=\"UL_1E6AB5CCB767402E97FDDBAFEB58B11C\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-3A72EAF6-6B18-4F14-96F1-D00D4FA95DA7\"></a>Render items marked as participating in post effects \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-94B85D67-8AF6-40DD-B8AB-0382AC8C2997\"></a>2D Motion blur main algorithm \n\
                           				  \n\
                        </p> <a name=\"UL_2183317896C245F09AD2DC2C76B2D403\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-1099AA79-CD93-40E4-9435-C5E277523459\"></a>Full screen quad rendering only \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-21F46760-F4C7-4AC5-AC70-583BACE05237\"></a>Depth of field post effect \n\
                     			 \n\
                  </p> <a name=\"UL_2B6D3089602A4312B5787A5E3993ED57\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-C12CAB49-9F92-47C7-970C-D9348D626B16\"></a>Depth pass (P) \n\
                           				  \n\
                        </p> <a name=\"UL_0C764D76F51A44C4AC087403EA78FEE4\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-F40AC8F7-5CD3-4D50-BAD4-A33631026616\"></a>Opaque render items \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-E899DD3C-77D4-4E9E-B5D2-0C6226B98080\"></a>Transparent render items \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-039B29B1-5FE7-4026-B6C2-5FF4B5FFBCB3\"></a>2D depth of field algorithm \n\
                           				  \n\
                        </p> <a name=\"UL_6021FFD1A6024255B1E7281CE0303421\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-C5AFC16F-09C4-40A1-8FAD-E7C1AF7E5A82\"></a>Full screen quad rendering only \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-72E57D5E-D6F5-4988-BD42-1611B2AE038E\"></a>Mask Rendering \n\
                     			 \n\
                  </p> <a name=\"UL_2A53EC5AECCD49F1A590ACD8641DEBE7\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-55598B7A-FA12-46E1-A02D-FC2F0E468587\"></a>Mask creation \n\
                           				  \n\
                        </p> <a name=\"UL_1890D77498174019ACD4BE7E0082DD4C\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-1143AFFC-FBD1-4A8B-B25C-5E5235B4709E\"></a>Render items marked as not participating in post effects (P) \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-E1553DEA-1971-451A-9F33-719BEF389515\"></a>Mask composite \n\
                           				  \n\
                        </p> <a name=\"UL_BF319D3F6D964032ABB1211414EC8C20\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-48F41FF0-6CB3-4F12-AA82-C7DF846310D3\"></a>Full screen quad rendering only \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-B8B943B7-96E9-47B7-B0CE-8C96220BB492\"></a>Pre-scene opaque UI render items (P) \n\
                     			 \n\
                  </p> <a name=\"UL_84E5BC8E50364FAB88E3974B5BF5F66B\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-A93D1AD2-2B71-41E8-ADB9-BD49E346A28F\"></a>When post effects are enabled \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-BB854C82-BCA5-464F-A8F6-65E6075C8BD2\"></a>Post UI rendering of scene elements \n\
                     			 \n\
                  </p> <a name=\"UL_B2041169BF2E4C37AF00A05EDBF33130\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-5EB47A7E-FF7A-482C-80FD-066D6714E33E\"></a> If post-effects are enabled \n\
                           				  \n\
                        </p> <a name=\"UL_2F89C312DED84F03BD9AEEAD2B972B7B\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-D7956663-D863-4704-8657-F420C0E729E6\"></a>Opaque UI render items (P) \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-DEB2F4B8-E94D-445C-8C9F-9C0545CEC826\"></a>Opaque 2D UI render items (P) \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-A22F133A-E26C-4505-A318-FD990F8089DE\"></a>Semi-transparent bitmap render items. (P) \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-9A176191-E84C-4605-9509-B6A8A889F494\"></a>Transparent UI render items (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-7BAF99C5-30F2-4365-9E94-99B6D3377F4E\"></a>Transparent UI 2D render items (P) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-49D9ACBC-5715-4FCC-889F-73641C31E4D5\"></a> UI Render Items marked as \n\
                           					 <em class=\"strong\">x-ray</em> or drawing no depth test (P). Note that x-ray active components mode can trigger\n\
                           items to be added to this list, as well as explicit setting from the API. \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-C4EA21FB-381D-42D7-A06E-65D95FF2C74B\"></a>Post UI rendering of non-scene elements: \n\
                     			 \n\
                  </p> <a name=\"UL_CC2B635D22BA4A3C8A5D2F4DCE58814D\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-F6FFB461-DBF4-4885-92F7-D156F054DA39\"></a>Manipulator UI item rendering, excluding 2D text items. (See \n\
                           					 <span class=\"char_link\"><a href=\"#!/url=./files/GUID-5C42B5A3-C0D6-4C70-97C2-576475B63023.htm#SECTION_CBFDB9E7FA2446C39149E8D9C589E361\">Manipulators</a></span>.) \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-6930F678-E3F6-4C69-8CEA-E4D2981DF96E\"></a><em class=\"mild\">On top</em> UI drawable rendering. Includes: internal 2D camera UI, sculpting drawing, and 2D\n\
                           manipulator text. \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-518371F5-FDAE-4053-8123-C88B29D1E7FA\"></a>2D and 3D overlay UI item rendering \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-AF5B49E9-8EC4-4252-801A-B1D824364669\"></a>If off-screen rendering \n\
                     			 \n\
                  </p> <a name=\"UL_E484A8C587B94732AB74ABF9FD5FDFE7\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-D926B298-8C00-489F-9F05-7B5369B9AA1C\"></a>HUD rendering \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-E91A933F-D531-462D-80CA-33AE9C366B77\"></a>Color Management \n\
                           				  \n\
                        </p> <a name=\"UL_0B19E3F992324AE99B2FE3BEE61E5C6F\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-01A696D8-9CA4-421C-8AAD-C45EDBBF4D28\"></a>Quad rendering only \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-31B09F4C-86C3-43FA-95E6-EFA537CAF854\"></a>Post scene render notification \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-2A5A1FD5-A575-4D06-B5F3-5D230D0323FC\"></a>Post frame render notification \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-466196FE-E9EB-411E-8F5C-B8788A5FF8D4\"></a>If on-screen rendering \n\
                     			 \n\
                  </p> <a name=\"UL_0300564A8054421688F847F824208C65\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-EF762854-7864-4D24-B28E-10D6B4F9524A\"></a>Color Management \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-43E9FE28-66C5-41F3-8C65-3F5DFFD18C88\"></a>HUD \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-4994BBB2-8D51-4338-A507-6D23D7AF126A\"></a>Viewport post render notification \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-D891D416-A083-4969-A14B-60F8633F8FAC\"></a><em class=\"mild\">Present</em> on-screen \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_62D62E880F5E4084A87DD0D0777D5264\"></a> \n\
            <h2><a name=\"GUID-03A130E9-175B-4A1A-8023-3E45599E828D\"></a>Transparency rendering\n\
            </h2> \n\
            <p><a name=\"GUID-C876DB4B-F625-4A04-9241-C45279B386B2\"></a>The process of rendering transparent items differs based on the transparency algorithm\n\
               chosen, and the categorization of the item. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-79003182-6528-4744-A339-A6FEA4274100\"></a>The basic logic is: \n\
               		\n\
            </p> <a name=\"UL_4D3617645C024DDDB5B23A557AC74CBA\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-01ACDD9B-F77A-463F-81B4-F1980C18C9D3\"></a>Non-UI render items that indicate support for advanced transparency (<span class=\"MenuCascade\" id=\"GUID-4D48CAA9-307F-49C9-95F7-8E5FB3AD33A6\">Weighted Average</span>, \n\
                     				<span class=\"MenuCascade\" id=\"GUID-FA744D61-2DC2-4D08-9E94-65E691DF002C\">Depth Peeling</span>) (P) \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-652BBEBB-3E0B-4C13-A5F5-A9B318954AA3\"></a>Non-UI render items that do not support advanced transparency; or, if \n\
                     				<span class=\"MenuCascade\" id=\"GUID-62EECF60-CF53-4688-AA39-CBA2F93A0547\">Object Sorting</span> or \n\
                     				<span class=\"MenuCascade\" id=\"GUID-E9949327-3532-4209-954A-F1451BD65107\">Simple</span> transparency is used. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-5E18D4D5-C3A6-44EF-AB5F-8E247A157C41\"></a>Note that the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setSupportsAdvancedTransparency()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1cb8ade4b1a11be0c16c7ffc2a2e292c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem::setSupportsAdvancedTransparency()</a></span> method can be used to explicitly opt out of advanced transparency. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3552E4104363428496513CED0696FAEA\"></a> \n\
            <h2><a name=\"GUID-7F813AF0-5390-4E48-8CC0-7077FFF8FD42\"></a>Particle rendering\n\
            </h2> \n\
            <p><a name=\"GUID-19F9B7A9-4F11-4AE3-8964-9B09EE286B69\"></a>Different type of items can be created for particle systems, since the object can\n\
               specify different display variations. Points and streaks, for the most part, are added\n\
               to the opaque or transparent render item lists and the transparent bitmap lists. Any\n\
               numeric will also end up in x-ray lists. (Note that stock numeric shaders acquired\n\
               from \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MShaderManager</a></span> also end up in x-ray lists.). Sphere and blobby items will end up on opaque or opaque\n\
               UI lists (latter for wireframe). Cloud and tube will end up in transparent or opaque\n\
               UI lists (the latter for wireframe). \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7C920E165E9246D6A7D6EFAB03793EC2\"></a> \n\
            <h2><a name=\"GUID-71189D1B-F5EF-48C6-8105-76061E593D75\"></a>Shadow pass rendering\n\
            </h2> \n\
            <p><a name=\"GUID-02FB3B62-2AA4-4E9A-B5FB-00A9A6473C96\"></a>Any shadow maps used for 3d scene rendering are updated during pre-scene rendering\n\
               as needed. Only render items (not UI drawables) are considered for shadow map creation,\n\
               with the following sequencing: \n\
               		\n\
            </p> <a name=\"UL_30F21472ACC24930B35D4FFF8CADB920\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-EB9175F6-B1C8-45BA-8F6D-DCBE848227FA\"></a>Perform any render item filtering \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-12A733CD-CFF4-4F2B-8AE6-43855E6DF9C2\"></a>Draw opaque render items (P) \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1DCB49A8A7664F7BACA68CFECA2CB94E\"></a> \n\
            <h2><a name=\"GUID-FCDA31FD-F4AC-47B9-B9D4-812B849C5694\"></a>Image Plane rendering\n\
            </h2> \n\
            <p><a name=\"GUID-2C436C37-8BA0-4FAF-B1FF-BE664FD340E2\"></a>Image plane rendering can create opaque or transparent objects, but they are categorized\n\
               to not take part in post-effects and hence are always added to non post-effect lists.\n\
               \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_8B26FD75A51349B28D70A1F2A17694D4\"></a> \n\
            <h2><a name=\"GUID-DFAF413C-8F13-48E2-ABBA-4AC84AC4A5A4\"></a>API UI Draw Manager\n\
            </h2> \n\
            <p><a name=\"GUID-0C677873-994C-4480-8440-7D3459FCF5EE\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MUIDrawManager</a></span> is the API interface for handling various UI drawing, and is available from various\n\
               API interfaces. Both API as well as internal drawing can produce different drawables\n\
               based on the class methods used. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-7E17B6B9-15CC-4BFC-A9C0-6BD974134638\"></a>For object override and render override drawing, the following general mapping occurs:\n\
               \n\
               		\n\
            </p> <a name=\"UL_7A43AC4376EB4188BAEB1C88071C023E\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-B49141BA-3CB9-445E-899E-64B843DBA967\"></a>Text: Add item to x-ray list \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-3B7F3756-2634-4408-9A33-CEDA1C00DAF0\"></a> Icons: Add item to opaque UI list. Note that they are not added to the x-ray list.\n\
                     \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-6357614F-2472-4740-BC09-02BB0778B52B\"></a>Mesh: This includes the various geometric primitive types, and stock geometry. Note\n\
                     that these items will never participate in shadow or post effects passes, but can\n\
                     be lit and shaded using Maya lights, depending on primitive type. \n\
                     			 \n\
                  </p> <a name=\"UL_246C1F3CFCE049759DDA9D5EAB819F44\"></a><ul>\n\
                     <li> \n\
                        <p><a name=\"GUID-94AA0B90-BF0B-4FC8-B5BA-BB891A3AD765\"></a>If opaque \n\
                           				  \n\
                        </p> <a name=\"UL_32CB8027CD114A48B74FF0AFED3FA176\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-1A0EC778-6940-4DD5-B057-9490E15B267F\"></a>If (3d) \n\
                                 						\n\
                              </p> <a name=\"UL_F6A8E2868A1045B7880E51ACD3C14C81\"></a><ul>\n\
                                 <li> \n\
                                    <p><a name=\"GUID-0F440FB1-8881-497D-B4C9-6137CFB8DB00\"></a>Add item to opaque UI list. \n\
                                       							 \n\
                                    </p> \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-BC7D35FA-0DCC-4C1C-BEED-735BE24AC8ED\"></a>Else \n\
                                 						\n\
                              </p> <a name=\"UL_62FC17D2830646DBAB36CA1CC333D055\"></a><ul>\n\
                                 <li> \n\
                                    <p><a name=\"GUID-87112799-C032-4611-9D58-25B3FC86DDD6\"></a>Add item to opaque 2d UI list. \n\
                                       							 \n\
                                    </p> \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-6D97C6A9-38D3-4667-9B4A-264314AEEEA6\"></a>Items are also added to the non-post effect list since they are considered to be UI.\n\
                                 \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-70E8657C-AA3A-453E-8571-A31EA9225AC9\"></a>Else if transparent and filled and not points or lines \n\
                           				  \n\
                        </p> <a name=\"UL_EA9813F3738444D185BF171083813410\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-7409C084-3EC9-4E62-A9A6-19A95920D111\"></a>if (3d) \n\
                                 						\n\
                              </p> <a name=\"UL_F2CC22C6F7D747DA834640359B1B5CFF\"></a><ul>\n\
                                 <li> \n\
                                    <p><a name=\"GUID-BDECA193-D292-4169-8A15-6575E80E950A\"></a>Add item to transparent UI list. \n\
                                       							 \n\
                                    </p> \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-E7C5491B-0533-4F09-8767-621B082B96BB\"></a>Else \n\
                                 						\n\
                              </p> <a name=\"UL_467D97759C1C4D289039617661D6ECBD\"></a><ul>\n\
                                 <li> \n\
                                    <p><a name=\"GUID-6C268125-1CBE-41ED-A89D-48BC81381778\"></a>Add item to transparent 2d UI list. \n\
                                       							 \n\
                                    </p> \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-A31BC1C2-DABC-4B08-B5F6-6C8D90D61BBD\"></a>Items are also added to the non-post effect list since they are considered to be UI.\n\
                                 \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li> \n\
                        <p><a name=\"GUID-62050BFD-538C-4ADC-9A20-51AFF4A4F272\"></a>If drawing in x-ray mode \n\
                           				  \n\
                        </p> <a name=\"UL_084668D5814A4FAF9D290C0732A0C792\"></a><ul>\n\
                           <li> \n\
                              <p><a name=\"GUID-613582FC-ECB7-4900-8B09-7AE63AFE9919\"></a>Add item to x-ray list. \n\
                                 						\n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
            </ul> \n\
            <div class=\"section\"><a name=\"SECTION_CBFDB9E7FA2446C39149E8D9C589E361\"></a> \n\
               <h3><a name=\"GUID-B3E0C6F5-EF55-4C29-9A14-F655312DFF9C\"></a>Manipulators\n\
               </h3> <a name=\"UL_41C997CD99234ED6AA5AEA90B67818F3\"></a><ul>\n\
                  <li> \n\
                     <p><a name=\"GUID-45AFC304-83E9-4382-AC33-8B61B091FE49\"></a>All items are added to the manipulator item list, except for 2D text which will be\n\
                        added to the \n\
                        				  <em class=\"mild\">on top</em> list. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><a name=\"GUID-84A1E525-221A-4BDC-A17C-0EFA35E58403\"></a><em class=\"mild\">footPrintManip</em> example: The \n\
                        				  <em class=\"mild\">Stretch Me!</em> and \n\
                        				  <em class=\"mild\">Stretch Me 2D!</em> text is drawn on top of the footprint locator (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxDrawOverride</a></span>) text (x-ray) and uiDrawManager (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxDrawOverride</a></span> ) sample text (transparent UI 2D). \n\
                        				\n\
                     </p> <a name=\"FIG_81F22BCB89E24C798CFA21A6E46D3DAF\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-698B845C-2D1D-4A7D-B95A-568C4492DDDC-low.png\"></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_148747325F5E490FA8915796A8DDCEA4\"></a> \n\
               <h3><a name=\"GUID-2A1B359C-A8FB-45B1-A014-D513E89D73AF\"></a>Tool context drawing\n\
               </h3> <a name=\"UL_70D3D4CD97B847C78BDEBBC32F08F1C8\"></a><ul>\n\
                  <li>All items will be added to the 2D or 3D overlay item list (see below). \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_DEBCA504253941E488498878D2B6F689\"></a> \n\
               <h3><a name=\"GUID-D96D09B1-D9C6-4B75-96B7-28A49DA8C769\"></a>UV Editor\n\
               </h3> <a name=\"UL_8E41EC74641B4E688016BD3BA2C5CB63\"></a><ul>\n\
                  <li>2d meshes that are used for drawing the background texture are added as items to the\n\
                     pre UI list. \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_85C4DE3E93BC4E84B003B867B6DF1D2E\"></a> \n\
            <h2><a name=\"GUID-7E3AD0CC-047B-4EEC-A92A-9395F6D343BE\"></a>API Overlay Rendering\n\
            </h2> \n\
            <p><a name=\"GUID-AE92049A-955C-49CD-97F3-119A32BB6C9F\"></a>Tool context drawing all reside within the pipeline operations for drawing overlays.\n\
               This means items are added to the 2D or 3D overlay lists. This applies for 3d viewports\n\
               as well as the \n\
               		  <span class=\"MenuCascade\" id=\"GUID-D0372DBB-CE32-4038-BBE1-D18A29BAC011\">UV Editor</span>. 3D scene elements are generally not redrawn when drawing overlays. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D5AAD92049924EBEA867EA9DC8B61FBC\"></a> \n\
            <h2><a name=\"GUID-F860E61C-2DB4-4302-8DA7-39133472A6FE\"></a>API \n\
               		  <span class=\"MenuCascade\" id=\"GUID-512A58DE-EAFC-46B6-A18C-0D8A58D65BDC\">UV Editor</span> Rendering\n\
            </h2> \n\
            <p><a name=\"GUID-FA72B342-46CF-4FF9-A206-4568BED76AE4\"></a>The background texture rendering can be supplied by a shader override (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span>). In this case, the drawing is done via \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MUIDrawManager</a></span> and is always drawn before any object UI, or 2D manipulators. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_215FD9D161CC48728E8AE44D2EA1AF46\"></a> \n\
            <h2><a name=\"GUID-A9A37F56-B199-43F4-95DF-6C4FE440F66D\"></a>API Object Rendering\n\
            </h2> \n\
            <div class=\"section\"><a name=\"SECTION_D96EFC1B22A84F12B8F7FD00A4DCA481\"></a> \n\
               <h3><a name=\"GUID-F5501CC1-A2A9-4044-A3CF-CDD7AB58FF05\"></a>MPxDrawOverride\n\
               </h3> \n\
               <p><a name=\"GUID-C4096391-2150-4996-8793-F984F6909239\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxDrawOverride</a></span> drawing is, by default, categorized as an opaque render item, but never participates\n\
                  in any post effects, nor transparency, although it can participate in shadow map creation.\n\
                  \n\
                  		  \n\
               </p> <a name=\"UL_81DE4816D27643D69EBCC1C262A87E8F\"></a><p class=\"list-intro\"><a name=\"GUID-CDE80D0F-2851-46BE-BF98-B310BFAE8617\"></a>Developer kit example: \n\
                  			 <em class=\"mild\">rawFootPrintNode</em></p>\n\
               <ul>\n\
                  <li> \n\
                     <p><a name=\"GUID-141D99F4-265E-4D31-A02B-E7AF9B8DEA72\"></a>1 internally defined item is added to the opaque list \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><a name=\"GUID-DA75564E-2154-4F76-852E-1F9B68D9774D\"></a>1 item is added to the x-ray list (text via \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MUIDrawManager</a></span>). \n\
                        				\n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_7A3BC938689A49989202AC6BDA102928\"></a> \n\
               <h3><a name=\"GUID-B542E974-E46E-4889-B69D-36809AE15BFE\"></a>MPxGeometryOverride and MPxSubSceneOverride\n\
               </h3> \n\
               <p><a name=\"GUID-77C5DDDA-2300-431B-8C9F-B0253980A397\"></a>Render items created by \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span> and \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSubSceneOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSubSceneOverride</a></span> may or may not be categorized as opaque UI or non UI render items, depending on the\n\
                  properties set per item. \n\
                  		  \n\
               </p> <a name=\"UL_10CDB99CF81F4ED896ECAB20AFDE8353\"></a><p class=\"list-intro\"><a name=\"GUID-690F86BA-CF4B-4D00-9AAB-36E9C6079B4E\"></a>Developer kit example: \n\
                  			 <em class=\"mild\">footPrintNode_GeometryOverrride</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span>)\n\
               </p>\n\
               <ul>\n\
                  <li> \n\
                     <p><a name=\"GUID-D3517458-B228-4346-A24F-B64821B5F6FA\"></a>Since a \n\
                        				  <span class=\"code\" translate=\"no\">RenderItemType</span> of \n\
                        				  <span class=\"code\" translate=\"no\">MHWRender::MRenderItem::DecorationItem</span> is used for all custom render items, they are categorized as opaque UI items. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><a name=\"GUID-ADC35F18-7563-4941-83D1-78353FAC2E51\"></a>Up to 4 explicitly defined items (2 for wireframe, and 2 for filled) may be added\n\
                        to lists when unconsolidated, and wireframe and shading draw modes are both enabled.\n\
                        \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><a name=\"GUID-65435507-157D-4EFF-8B35-F689449F133A\"></a>The minimum is 1 for wireframe or 1 for filled when consolidation is enabled, and\n\
                        only one draw mode is enabled. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
               </ul> <a name=\"UL_7C953BA599E24019B91A987CF90191E9\"></a><p class=\"list-intro\"><a name=\"GUID-53CFD8E2-B601-4E65-8EA6-509BC682CD22\"></a>Developer kit example: \n\
                  			 <em class=\"mild\">apiMeshShape</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span>)\n\
               </p>\n\
               <ul>\n\
                  <li> 6 opaque UI render items (wire, dormant vertices, active vertices, face centers,\n\
                     active wire, filled faces). They have a \n\
                     				<span class=\"code\" translate=\"no\">RenderItemType</span> of \n\
                     				<span class=\"code\" translate=\"no\">MHWRender::MRenderItem::DecorationItem</span>. \n\
                     				<a name=\"FIG_64C053E91074457191DE806FA6B1DDAA\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D3DCD51E-9490-4F63-A63B-E32158F6437C-low.png\"></div> \n\
                  </li>\n\
                  <li>1 opaque render item due to internal shader assignment. \n\
                     				<span class=\"code\" translate=\"no\">RenderItemType</span> is \n\
                     				<span class=\"code\" translate=\"no\">MHWRender::MRenderItem::MaterialSceneItem</span>. Therefore, it will participate in post-effects, for instance. \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
               <div class=\"section\"><a name=\"SECTION_233C2DEF81344CE0BA9E9D3D11763BE4\"></a> \n\
                  <h4><a name=\"GUID-039B8DD4-E57E-445A-B7C7-915E32560013\"></a>Developer kit example: \n\
                     			 <em class=\"mild\">apiMeshShape</em> (MPxSubSceneOverride)\n\
                  </h4> \n\
                  <p><a name=\"GUID-F8C5D93D-0EEC-4BBE-ABA8-0B7A680BF442\"></a>There are 6 transform instances of the same object in this example. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-9738E70F-CE94-4F22-8954-737A01149B74\"></a>For a single object, there is 1 item added to the opaque list (shaded). This item\n\
                     will also be added to the post-effects list. \n\
                     			 \n\
                  </p> <a name=\"FIG_747B6DE1EF604AECBB39460192B30451\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-89B60122-7EAD-4053-AEEE-9589732E1AB7-low.png\"></div> \n\
                  <p><a name=\"GUID-A292D029-B6D8-4598-B53E-2BE175EF26F2\"></a>Because the subscene override uses hardware instancing; therefore, in total, there\n\
                     is only 1 item added. Each item will use hardware instance drawing with a different\n\
                     world space transform for each instance. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-0427E5C3-001C-425E-82EF-2734B0C33489\"></a>When an instance of an object is selected: \n\
                     			 \n\
                  </p> <a name=\"FIG_9B3A2C2FE8EB483C9988B5B5FC1AB7D5\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D8DE1312-A0AD-434D-AEC6-B0F7A25A5F4F-low.png\"></div> \n\
                  <p><a name=\"GUID-008371C7-7508-4F11-9067-6730D1DC9374\"></a>1 wireframe item is added to the opaque UI list. \n\
                     			 \n\
                  </p> <a name=\"FIG_5F31108AB0A84A3B8631386E6BAF9897\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F7B433D6-D6E1-4B3A-8ADC-985DF8C31738-low.png\"></div> \n\
                  <p><a name=\"GUID-73D12391-70A3-4665-92B1-793A25F85E6B\"></a>When vertices are displayed, there is 1 additional item added to the opaque UI list.\n\
                     \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-B7621AA2-D0E8-41B6-8087-E6819FA5DC7A\"></a>Wireframe-on-shaded results in 2 UI items being added: One for dormant and 1 for active\n\
                     wireframe. \n\
                     			 \n\
                  </p> <a name=\"FIG_03033429EA1047229F218C7F0DC73468\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3BE824E6-066A-449B-8751-7B0B0A9FE1AD-low.png\"></div> \n\
                  <p><a name=\"GUID-DFCCA304-0B52-4CC4-992D-9171D4FEB448\"></a>Two items are also added for bounding box. They have a \n\
                     				<span class=\"code\" translate=\"no\">RenderType</span> of \n\
                     				<span class=\"code\" translate=\"no\">MHWRender:: <a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::NonMaterialSceneItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a688a4360e982358b90610f58d4eef49ea051cc5c371043b627d1d7bee0d06e030&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem::NonMaterialSceneItem</a></span>, which means they are not considered as scene items but are still categorized and\n\
                     added to the opaque UI list. \n\
                     			 \n\
                  </p> <a name=\"FIG_34E6D06F6D1C40A488666F5D59E9F81C\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3CB4F77C-DD0B-4A98-B2C8-9E7C493A24AE-low.png\"></div> \n\
                  <p><a name=\"GUID-F8C24E2B-4087-46A8-A339-D1FA9D899E29\"></a>Wireframe, vertices and bounding box items are all added to the non-post effects list.\n\
                     \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_94388044B95B47CAB324D639466526E1\"></a> \n\
                  <h4><a name=\"GUID-41424C5D-3FA9-432B-8572-99138C8752EB\"></a>Shaders\n\
                  </h4> \n\
                  <p><a name=\"GUID-D9A178F1-92EC-4BB5-AA39-DF4505514E12\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span>, \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShadingNodeOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShadingNodeOverride</a></span> and internal Maya assigned shaders always produce opaque or transparent non-UI render\n\
                     items. As such, they are added to the post-effects lists, and are also rendered for\n\
                     shadow map passes. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-92D9394B-C85C-4E10-A94C-FC2C1BAB2B37\"></a>As documented in the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span> C++ API Reference documentation, the plug-in instance will, by default, only be called\n\
                     to draw in the main color pass unless overridden. For example, the normal-depth pass\n\
                     for SSAO will not by default call back to the plug-in. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-C2439656-974B-4162-9C55-CDC9335346F3\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShadingNodeOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShadingNodeOverride</a></span> only provides a single shader implementation, which in turn is used for the main\n\
                     color pass. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_93DAACC075A44F41A4583787D945DBD9\"></a> \n\
               <h3><a name=\"GUID-6D68C69B-F476-4C66-8788-A3599A3E4FED\"></a> Item list tracking \n\
               </h3> \n\
               <p><a name=\"GUID-210350C2-86A9-42F1-B2BA-10901C807AF5\"></a>It is possible to obtain trace information regarding the non-empty lists that are\n\
                  available for a regular 3d beauty render, as well as overlay rendering for 3d viewports.\n\
                  The command: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">ogs -traceRenderPipeline true;</pre></div> \n\
               <p><a name=\"GUID-E8BE304C-254A-4E28-AD41-A2BA5692008D\"></a>can be used to send debug output to the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-67D3A0F2-BD9F-4435-9134-B5E8EAE63B4A\">Script Editor</span> in interactive mode, or to \n\
                  			 <span class=\"code\" translate=\"no\">stderr</span> in command line mode. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-845AA3DE-0A54-4147-8C6D-F23211365D8E\"></a>For example, tracing a sphere drawn filled with wireframe may produce output as follows:\n\
                  \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Rendering [modelPanel4] [3d Beauty Render] // \n\
// Count for list: [Opaque UI] = 1 // \n\
// Count for list: [Opaque] = 1 // \n\
// Count for list: [Post Effect] = 1 // \n\
// Count for list: [Non Post Effect] = 1 //</pre></div> \n\
               <p><a name=\"GUID-CE7379B1-C939-4E4D-B3D8-3A0AE6F03708\"></a>For context, the rendering destination (same value as returned by \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::renderingDestination()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a0df712533d76bdc96f2b49f4767ed85e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFrameContext::renderingDestination()</a></span>) is given, along with the render performed. Here, the name \n\
                  			 <em class=\"mild\">3d Beauty Render</em> is returned to indicate an internal render. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-702CA642-F2D8-4F5F-AA68-49FE750858E3\"></a>The results indicate that 1 opaque UI item (wireframe), and 1 opaque item (filled)\n\
                  have been categorized. In addition, the filled item is queued for post-effect drawing,\n\
                  and the wireframe is queued for non post-effect drawing. The fact that they are available\n\
                  does not necessarily mean that the list will be rendered, as this would be dependent\n\
                  on whether any post-effects are enabled. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-0C4AFC23-192C-4023-BEA8-03D76C874CCF\"></a>The lists are not necessarily given in the order that they will be used, and each\n\
                  list is only given once per scene render. The sequencing in this section should be\n\
                  referenced to determine where a given list could be drawn. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-5033E8AC-0954-4365-9759-3934D0AB5095\"></a>Multiple scene renders hence show the items for each render. For example, stereo rendering\n\
                  could appear as follows: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Trace[StereoPanel][stereoOverrideVP2] // \n\
// Count for list: [Opaque UI] = 18 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 19 // \n\
// Count for list: [Opaque UI] = 18 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 19 // \n\
// Count for list: [HUD] = 1 //</pre></div> \n\
               <p><a name=\"GUID-5C583280-4EBF-4DDE-B6C6-2C315A2928D2\"></a>The second to fifth line represent one scene draw and the sixth to ninth represent\n\
                  another. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-3A77378A-C742-4F1E-84EC-6EBF4E026DC7\"></a>Note that when a render override (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderOverride</a></span>) is active for the trace, then the UI name of the override is provided as part of\n\
                  the trace. In this case, the \n\
                  			 <em class=\"mild\">stereoOverrideVP2</em> override name is shown. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-2332BF1D-2D9D-4346-B58A-EC30CCE5F53B\"></a>In another example, when tracing the \n\
                  			 <em class=\"mild\">viewOverrideSimple</em> plug-in, the \n\
                  			 <em class=\"mild\">Simple VP2 Override</em> name is given: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Trace[modelPanel1][Simple VP2 Override] // \n\
// Count for list: [Opaque UI] = 17 // \n\
// Count for list: [Pre-Opaque UI] = 2 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 18 // \n\
// Count for list: [Orthographic On-Top UI] = 5 // \n\
// Count for list: [HUD] = 1 //</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";