var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-66ADA1FF-3E0F-469C-84C7-74CEB36D42EC\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>PyQt and PySide Widget Best Practices</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-66ADA1FF-3E0F-469C-84C7-74CEB36D42EC\"></a><div class=\"head\">\n\
            <h1>PyQt and PySide Widget Best Practices</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4E1669DB0CFE4D7DB39FFE13CACED044\"></a> \n\
            <h2><a name=\"GUID-080FBB43-F7ED-49BB-80A9-0BF20FC20CAA\"></a>Maintain a Reference to your Widget\n\
            </h2> \n\
            <p><a name=\"GUID-23BC5CE8-291A-4B5C-BCBA-CF29660B27A1\"></a> If you are using PyQt or PySide to customize Maya\'s user interface, you should make\n\
               sure to parent your widget under an existing Maya widget, such as Maya\'s main window.\n\
               Otherwise, if the widget is un-parented, it may be destroyed by the Python interpreter\'s\n\
               garbage collector if a reference to it is not maintained. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-BC36D5E8-827E-45ED-AD6A-54FDFE1A0186\"></a>The following code sample exemplifies this best practice. Note that this code will\n\
               also work by importing the PyQt module instead of PySide. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from maya import OpenMayaUI as omui \n\
\n\
try:\n\
  from PySide2.QtCore import * \n\
  from PySide2.QtGui import * \n\
  from PySide2.QtWidgets import *\n\
  from PySide2 import __version__\n\
  from shiboken2 import wrapInstance \n\
except ImportError:\n\
  from PySide.QtCore import * \n\
  from PySide.QtGui import * \n\
  from PySide import __version__\n\
  from shiboken import wrapInstance \n\
\n\
mayaMainWindowPtr = omui.MQtUtil.mainWindow() \n\
mayaMainWindow= wrapInstance(long(mayaMainWindowPtr), QWidget) \n\
\n\
# WORKS: Widget is fine \n\
hello = QLabel(\"Hello, World\", parent=mayaMainWindow) \n\
hello.setObjectName(\'MyLabel\') \n\
hello.setWindowFlags(Qt.Window) # Make this widget a standalone window even though it is parented \n\
hello.show() \n\
hello = None # the \"hello\" widget is parented, so it will not be destroyed. \n\
\n\
# BROKEN: Widget is destroyed \n\
hello = QLabel(\"Hello, World\", parent=None) \n\
hello.setObjectName(\'MyLabel\') \n\
hello.show() \n\
hello = None # the \"hello\" widget is not parented, so it will be destroyed.</pre></div> \n\
            <p><a name=\"GUID-58CDB0CD-EDFC-4A79-BF7D-38D42682216C\"></a>If you are using the PySide mix-in classes described below, this parenting will be\n\
               handled for you automatically. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6F19D0A948134F118E3C49DB216D1A65\"></a> \n\
            <h2><a name=\"GUID-63FFC519-6186-4B81-A0D0-D5532CF1B91D\"></a>Use the maya.app.general.mayaMixin Classes\n\
            </h2> \n\
            <p><a name=\"GUID-1852C9AF-877E-4722-96E0-55E006D02F33\"></a>The \n\
               		  <span class=\"code\" translate=\"no\">maya.app.general.mayaMixin</span> module contains classes to help simplify the integration of PySide-based widgets\n\
               into Maya\'s UI. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-D43623A7-61F4-4A6A-AE65-AA16E54D96D2\"></a>The \n\
               		  <span class=\"code\" translate=\"no\">MayaQWidgetBaseMixin</span> class handles common actions for Maya Qt widgets during initialization such as: auto-naming\n\
               a widget so that it can be looked up as a string through \n\
               		  <span class=\"code\" translate=\"no\">maya.OpenMayaUI.MQtUtil.findControl()</span>, and parenting the widget under the main Maya window if no parent is explicitly specified,\n\
               so that the window does not disappear when the instance variable goes out of scope\n\
               (see \n\
               		  <em class=\"mild\">Maintain a Reference to your Widget</em> above). \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-A21FBDDE-495D-4DB3-A038-C3A1B0EDA212\"></a>To use the class, ensure that it appears in your widget\'s list of parent classes before\n\
               the Qt class that your widget derives from. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-9BD5A6BD-7FCA-402A-9BB5-1C93BA72E7AA\"></a>For information on the methods and properties provided by these classes, use the Python\'s\n\
               help function in the \n\
               		  <span class=\"MenuCascade\" id=\"GUID-AA19C411-3805-43E1-933D-F9F6E053B82F\">Python</span> tab of the \n\
               		  <span class=\"MenuCascade\" id=\"GUID-8DC622F1-FF95-496B-AE24-3D9E5ADB7653\">Maya Script Editor</span> (for example, \n\
               		  <span class=\"code\" translate=\"no\">help(MayaQWidgetDockableMixin)</span>). \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from maya.app.general.mayaMixin import MayaQWidgetBaseMixin\n\
\n\
try:\n\
  from PySide2.QtCore import * \n\
  from PySide2.QtGui import * \n\
  from PySide2.QtWidgets import *\n\
  from PySide2 import __version__\n\
  from shiboken2 import wrapInstance \n\
except ImportError:\n\
  from PySide.QtCore import * \n\
  from PySide.QtGui import * \n\
  from PySide import __version__\n\
  from shiboken import wrapInstance \n\
\n\
class MyButton(MayaQWidgetBaseMixin, QPushButton):\n\
    def __init__(self, parent=None):\n\
        super(MyButton, self).__init__(parent=parent)\n\
        self.setText(\'Push Me\')\n\
\n\
# Create an instance of the button and display it.\n\
#\n\
button = MyButton()\n\
button.show()\n\
\n\
# A valid Maya control name has been automatically assigned\n\
# to the button.\n\
#\n\
buttonName = button.objectName()\n\
print(\'# \' + buttonName)\n\
# MyButton_368fe1d8-5bc3-4942-a1bf-597d1b5d3b83\n\
\n\
# Losing our only reference to the button does not cause it to be\n\
# destroyed.\n\
#\n\
myButton = None\n\
\n\
# We can use the button\'s name to find it as a Maya control.\n\
#\n\
from maya.OpenMayaUI import <a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a>\n\
from shiboken2 import wrapInstance\n\
\n\
ptr = MQtUtil.findControl(buttonName)\n\
foundControl = wrapInstance(long(ptr), QPushButton)\n\
\n\
# Print out the button\'s text.\n\
#\n\
print(\'# \' + foundControl.text())\n\
# Push Me</pre></div> \n\
            <p><a name=\"GUID-36A66F88-BEE1-4F08-B428-38CBB7D5B660\"></a> The \n\
               		  <span class=\"code\" translate=\"no\">MayaQWidgetDockableMixin</span> class provides support for Maya\'s dockable actions. The docking behavior of the widget\n\
               is controlled through parameters passed to its \n\
               		  <span class=\"code\" translate=\"no\">show()</span> method, such as: \n\
               		  <span class=\"code\" translate=\"no\">dockable</span> to specify whether the widget should be dockable, \n\
               		  <span class=\"code\" translate=\"no\">area</span> to specify its default dock area, and so forth. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-6A7B7228-177A-49EE-9B7B-25D90E0AA934\"></a>To use the class, ensure that it appears in your widget\'s list of parent classes before\n\
               the Qt class that your widget derives from. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from maya.app.general.mayaMixin import MayaQWidgetDockableMixin\n\
\n\
try:\n\
  from PySide2.QtCore import * \n\
  from PySide2.QtGui import * \n\
  from PySide2.QtWidgets import *\n\
  from PySide2 import __version__\n\
  from shiboken2 import wrapInstance \n\
except ImportError:\n\
  from PySide.QtCore import * \n\
  from PySide.QtGui import * \n\
  from PySide import __version__\n\
  from shiboken import wrapInstance \n\
\n\
class MyDockableButton(MayaQWidgetDockableMixin, QPushButton):\n\
    def __init__(self, parent=None):\n\
        super(MyDockableButton, self).__init__(parent=parent)\n\
        self.setSizePolicy(QSizePolicy.Preferred, QSizePolicy.Preferred )\n\
        self.setText(\'Push Me\')\n\
\n\
# Show the button as a non-dockable floating window.\n\
#\n\
button = MyDockableButton()\n\
button.show(dockable=False)\n\
\n\
# showRepr() can be used to display the current dockable settings.\n\
#\n\
print(\'# \' + button.showRepr())\n\
# show(dockable=False, height=23, width=70, y=610, x=197, floating=True)\n\
\n\
# Change it to a dockable floating window.\n\
#\n\
button.show(dockable=True)\n\
print(\'# \' + button.showRepr())\n\
# show(dockable=True, area=\'none\', height=23, width=70, y=610, x=197, floating=True)</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";