var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-69E9D618-567A-42BD-BDDC-CD087BAA8934\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Rendering Framework</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-69E9D618-567A-42BD-BDDC-CD087BAA8934\"></a><div class=\"head\">\n\
            <h1>Rendering Framework</h1>\n\
         </div>\n\
         <p><a name=\"GUID-FE9B7DB7-583A-4473-92DC-7C0FD6A14AE5\"></a>To understand how the plug-in interface interacts with Maya, a frame of reference\n\
            needs to be provided. This section outlines the rendering framework of the current\n\
            hardware renderer. It also points out the differences and similarities between the\n\
            “old” and “new” rendering logic. \n\
         </p>\n\
         <p><a name=\"GUID-4B7EC9A7-E580-4DA7-8ADE-1688DEB8A4FF\"></a>There is now a clear separation of responsibilities and an underlying hardware rendering\n\
            framework exists. In the old system rendering was mainly the responsibility of DAG\n\
            objects, and now it is the responsibility of a renderer. \n\
         </p>\n\
         <p><a name=\"GUID-87EF5872-3B29-40BC-902F-28E4D1AD8CE7\"></a>First, there is a distinction between data which is used to represent Maya constructs\n\
            and data which is used for ren­dering. While Maya manages DAG objects, the rendering\n\
            framework maintains a separate database which tracks instances of Maya DAG objects.\n\
            This database is composed of constructs that we call <em class=\"strong\">renderable objects</em>. For the most part in general there is a 1:1 relation between renderable objects\n\
            and DAG instances. \n\
         </p>\n\
         <p><a name=\"GUID-7F96700A-B5D9-428C-90D1-22877FE70B12\"></a></p><img src=\"images/GUID-2FD18AD5-79C1-47A8-A0C1-467B83928DB1-low.jpg\"><p><a name=\"GUID-C80D48DB-B2FF-4B62-B5E6-495EFABAFF15\"></a>Figure 1: An example set of DAG objects in a hierarchy shown on the left. The result\n\
            could be 2 renderable objects for the 2 Maya DAG object instances. \n\
         </p>\n\
         <p><a name=\"GUID-2F5E8AB2-0E55-43EE-841E-34D971FAB7A5\"></a><em class=\"strong\">Synchronization</em> between Maya constructs and the rendering database is facilitated by a “dirtying”\n\
            or change man­agement mechanism which tracks all appropriate changes per node or DAG\n\
            object. This differs from the previous mechanism which required changes to be broadcast\n\
            to an arbitrary set of clients. \n\
         </p>\n\
         <p><a name=\"GUID-2BD2D4F3-DB44-4FEB-9F55-69F706A65F47\"></a>Unlike the old model, data <em class=\"strong\">update</em> is not driven by synchronization. In fact updates can no longer cause synchroni­zation\n\
            to occur as this would result in recursive updates. Synchronization is always actively\n\
            executing, while update is performed on-demand when a render is required. In the new\n\
            framework, a rendering request can be invoked non-interactively via the command line\n\
            or via the pre-existing idle refresh mechanism used for interactive (view­port) rendering.\n\
            One main difference to note is that non-interactive requests are always satisfied\n\
            while interactive requests may or may not be satisfied depending on whether the refresh\n\
            is executed. \n\
         </p>\n\
         <p><a name=\"GUID-376F2DF7-1E81-4E5D-B78A-B9CC195B3386\"></a>To satisfy a rendering request some kind of render loop logic needs to be performed.\n\
            This render loop can be visual­ized as a pipeline with various “phases.” For simplicity\n\
            we start with these familiar phases: \n\
         </p><a name=\"OL_AF7A524B37B749BAA60D4104B4D28BF0\"></a><ol type=\"1\" start=\"1\">\n\
            <li>Object level pruning of “renderable objects” (e.g. based on visibility) </li>\n\
            <li>Updating of data (Update Phase) </li>\n\
            <li>Sending down “renderables” </li>\n\
            <li>Drawing “renderables” </li>\n\
         </ol><img src=\"images/GUID-0BBF89BC-F22C-49C9-B412-AC7D36491EB1-low.jpg\"><p><a name=\"GUID-2E734D26-D3CE-4975-B8E5-8D99AC4BE34C\"></a>Figure 2: Renderables objects are fed in as input and pruned as required. Those that\n\
            are not pruned will perform synchronization and update as required and produce renderables.\n\
            These renderables may undergo further pruning before being sent to render. \n\
         </p>\n\
         <p><a name=\"GUID-4A983D6E-6869-48CD-8CD6-EBD2D2385258\"></a>The <em class=\"strong\">Update Phase</em> is responsible for synchronization and for determining what is “renderable.” We call\n\
            such ren­derable objects Render Items. Render items are passed down the pipeline and\n\
            additional logic is then applied to fil­ter or prune out what should actually draw\n\
            (“Renderable Pruning”). At the tail-end of the pipeline is the <em class=\"strong\">Draw Phase</em> which actually performs rendering. \n\
         </p>\n\
         <p><a name=\"GUID-8AF564E2-109F-49E0-8B81-C20ECD51CA61\"></a>Note that a <em class=\"strong\">Render Item</em> is left vague for the moment. For now, it is sufficient to know that it represents\n\
            an atomic unit containing both the render data and the render algorithm. Each unique\n\
            algorithm and each unique geometric primitive generally results in a unique renderable.\n\
            As an example, an algorithm to draw control points would require one renderable, while\n\
            one to draw filled triangles with bump mapping would require another. In this exam­ple\n\
            both the data primitive and the algorithm varies. \n\
         </p>\n\
         <p><a name=\"GUID-72BA3015-B0A4-4D40-862C-E02D6B6272C8\"></a>By contrast to the new organization, the old system looks like this: \n\
         </p><img src=\"images/GUID-EE7BCCF4-C9A5-41E2-BB8A-5A705F398501-low.jpg\"><p><a name=\"GUID-724C9561-9A21-4E9B-9FC4-F1289497E713\"></a>Figure 3: Without a database, a scene traversal is required. The object is responsible\n\
            for all tasks required to update and draw. \n\
         </p>\n\
         <p><a name=\"GUID-F3E6E75B-6DA4-4AB1-8173-67117CC62F77\"></a>Without a separate database, a full scan of Maya constructs in a scene is performed.\n\
            After initial object pruning, each object is free to draw itself. As there is no clear\n\
            separation between update and draw, this results in the ability to perform interleaved\n\
            evaluation, translation and draw in one “phase.” As there is no renderer, little cross-object\n\
            optimization can be performed. These are all undesirable properties and are discouraged\n\
            or disallowed in the new framework. \n\
         </p>\n\
         <p><a name=\"GUID-6C1FA44A-D900-4805-81D4-441B9CCFF2B3\"></a>We consider the new system of update as a <em class=\"strong\">pull</em> model where data is updated on demand and only if required. If nothing changes between\n\
            renders then the pipeline can run without interaction with the Maya scene. The old\n\
            model is seen as more of a <em class=\"strong\">push</em> model where for every render we rescan the entire scene and try to update every­thing\n\
            so it can be examined later on for relevance. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-D5015546-E6E0-46F1-AAC2-D6635CDAA2D0.htm\">Shader Driven Update </a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-ECD697A8-8AA3-419F-8A75-9BA95F4525C8.htm\">Geometry Update</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-F3D7C733-2850-468D-B6A8-EB51E3FD6F7B.htm\">Geometric Consolidation</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-14691FA8-573F-4205-80E4-063EBB8A14B5.htm\">The Render Loop</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-A2B3B4BE-3781-4302-A87A-F2F66BEECC46.htm\">The Renderer</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-F1523D13-47A9-48CF-B801-A001C64BB9D5.htm\">Comparison Against The Old System </a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-81D74C9D-0CD3-4627-BEC7-B5CB24C401DE.htm\">Interfaces To The Renderer</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";