var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-7BE4A6D9-7869-4065-A16B-D6D8D2D3B10E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Example: Creating a Depth Shader</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7BE4A6D9-7869-4065-A16B-D6D8D2D3B10E\"></a><div class=\"head\">\n\
            <h1>Example: Creating a Depth Shader</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4F88B7D1285C47B0823E136BD538225A\"></a> \n\
            <h2><a name=\"GUID-6ED58745-5BB1-47CA-80F0-06FD67BA239B\"></a>Example: Creating a Depth Shader\n\
            </h2> \n\
            <p><a name=\"GUID-7ECA4ED7-8BE6-4104-B901-183E91EF28C7\"></a> <em class=\"strong\">Filename:</em> <span class=\"code\" translate=\"no\">depthShader.py</span> \n\
            </p> \n\
            <p><a name=\"GUID-7681119A-B9A3-4783-81C4-58A2454F80AB\"></a> <em class=\"strong\">Rendered Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-15A987F9-3931-4858-8074-84F4C82C800F\"></a></p> <img src=\"images/GUID-1D5836F7-FBFE-4CFA-8B20-FCFC96A1D815-low.jpg\"> \n\
            <p><a name=\"GUID-6C51E730-5FB2-45DB-954C-53CF048462F8\"></a><em class=\"strong\">Program Summary</em>: The plug-in code below creates a new depth shader by inheriting from the <span class=\"code\" translate=\"no\">OpenMayaMPx.MPxNode</span> class. This shader can only be used by the Maya software shader. The <span class=\"code\" translate=\"no\">compute()</span> method is run for every rendered surface point, and determines the pixel\'s color\n\
               based on the surface point\'s Z-axis distance from the camera. \n\
            </p> \n\
            <p><a name=\"GUID-984B490E-29F6-48A3-895D-D7F26D399089\"></a>To access the depth of each rendered surface point, we create the following numeric\n\
               attribute in <span class=\"code\" translate=\"no\">nodeInitializer()</span>: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">depthShader.surfacePointAttribute = numericAttributeFn.createPoint(\'pointCamera\', \'p\')</pre></div> \n\
            <p><a name=\"GUID-730E328A-7087-440C-A1B6-FB3043E0E6D1\"></a>The name of this attribute (<span class=\"code\" translate=\"no\">\'pointCamera\'</span>), and its short name (<span class=\"code\" translate=\"no\">\'p\'</span>), are very important here, because they allow Maya to automatically connect our shader\n\
               node to the <span class=\"code\" translate=\"no\">samplerInfo</span> node\'s <span class=\"code\" translate=\"no\">pointCamera</span> output attribute. The <span class=\"code\" translate=\"no\">samplerInfo</span> node provides vital information about the point being rendered. For a full list of\n\
               its attributes, consult the <em class=\"strong\">Maya User Guide &gt; Technical Documentation &gt; Nodes &gt; samplerInfo</em>. You may also wish to consult the <em class=\"strong\">Appendix C: Rendering attributes</em> in the API Documentation for a detailed list of other rendering attributes. \n\
            </p> <a name=\"SECTION_EEB97A1A2CA6497BA04B5F50F06AC2DE\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-708EACC9-063B-4E1C-BFA7-23736D495AFC\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># depthShader.py\n\
\n\
import sys\n\
import math\n\
import maya.api.OpenMaya as OpenMaya\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
# Plug-in information:\n\
kPluginNodeName = \'pyMyDepthShader\'\n\
kPluginNodeClassify = \'utility/general\'\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>(0x870FE)\n\
\n\
# Default attribute values\n\
defaultNearDistance = 20.0\n\
defaultFarDistance  = 70.0\n\
defaultNearColor    = (1.0, 1.0, 1.0) # (r,g,b) white\n\
defaultFarColor     = (0.0, 0.0, 0.0) # (r,g,b) black\n\
defaultGamma        = 1.0\n\
minGamma            = 0.1\n\
maxGamma            = 5.0\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class depthShader(<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxNode</a>):\n\
    \'\'\' Creates a depth shader which renders in Maya\'s software renderer. \'\'\'\n\
    # Define the static variables to which we will assign the node\'s attributes\n\
    # in nodeInitializer() defined below.\n\
    surfacePointAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    nearDistanceAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    farDistanceAttribute  = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    nearColorAttribute    = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    farColorAttribute     = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    gammaAttribute        = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()    \n\
    outColorAttribute     = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxNode.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#a0769ac5b3ecf4060e81dfe4bdc6ed327&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxNode.__init__</a>(self)\n\
    \n\
    def compute(self, pPlug, pDataBlock):\n\
        \'\'\' \n\
        Node computation method. \n\
          - pDataBlock contains the data on which we will base our computations. \n\
          - pPlug is a connection point related to one of our node attributes (either an input or an output). \n\
        \'\'\'\n\
        if ( pPlug == depthShader.outColorAttribute ):\n\
            \n\
            # Get the data handles corresponding to your attributes among the values in the data block.\n\
            surfacePointDataHandle = pDataBlock.inputValue( depthShader.surfacePointAttribute )\n\
            nearDistanceDataHandle = pDataBlock.inputValue( depthShader.nearDistanceAttribute )\n\
            farDistanceDataHandle  = pDataBlock.inputValue( depthShader.farDistanceAttribute )\n\
            nearColorDataHandle    = pDataBlock.inputValue( depthShader.nearColorAttribute )\n\
            farColorDataHandle     = pDataBlock.inputValue( depthShader.farColorAttribute )\n\
            gammaDataHandle        = pDataBlock.inputValue( depthShader.gammaAttribute )\n\
            \n\
            # Obtain the (x,y,z) location of the currently rendered point in camera coordinates.\n\
            surfacePoint = surfacePointDataHandle.asFloatVector()\n\
            \n\
            # Since the camera is looking along its negative Z axis (the Y axis is \n\
            # the up vector), we must take the absolute value of the Z coordinate\n\
            # to obtain the point\'s depth.\n\
            depth = abs(surfacePoint.z) \n\
            \n\
            # Get the actual near and far threshold values.\n\
            nearValue = nearDistanceDataHandle.asFloat()\n\
            farValue = farDistanceDataHandle.asFloat()\n\
            \n\
            # Find the proportion of depth between the near and far values.\n\
            if( (farValue - nearValue) == 0):\n\
                # Avoid a division by zero if the near and far values somehow have the same value.\n\
                depthProportion = 0\n\
            else:\n\
                depthProportion = (depth - nearValue) / (farValue - nearValue)\n\
            \n\
            # Clamp the depthProportion value in the interval [0.0, 1.0]\n\
            depthProportion = max(0, min( depthProportion, 1.0 ) )\n\
            \n\
            # Modify the depth proportion using the gamma roll-off bias.\n\
            gammaValue = gammaDataHandle.asFloat()\n\
            depthProportion = math.pow(depthProportion, gammaValue)\n\
            \n\
            # Linearly interpolate the output color based on the depth proportion.\n\
            outColor = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFloatVector</a>(0, 0, 0)\n\
            nearColor = nearColorDataHandle.asFloatVector()\n\
            farColor = farColorDataHandle.asFloatVector()\n\
            \n\
            outColor.x = nearColor.x + ( ( farColor.x - nearColor.x ) * depthProportion )\n\
            outColor.y = nearColor.y + ( ( farColor.y - nearColor.y ) * depthProportion )\n\
            outColor.z = nearColor.z + ( ( farColor.z - nearColor.z ) * depthProportion )\n\
            \n\
            # Write to the output data.\n\
            outColorDataHandle = pDataBlock.outputValue( depthShader.outColorAttribute )\n\
            outColorDataHandle.setMFloatVector( outColor )\n\
            outColorDataHandle.setClean()\n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    \'\'\' \n\
    Creates an instance of our node plug-in and delivers it to Maya as a pointer. \n\
    \'\'\'\n\
    return depthShader() \n\
\n\
def nodeInitializer():\n\
    \'\'\' \n\
    Defines the set of attributes for our node. The attributes\n\
    declared in this function are assigned as static members to our\n\
    depthShader class. Instances of depthShader will use these attributes\n\
    to create plugs for use in the compute() method.\n\
    \'\'\'\n\
    # Create a numeric attribute function set, since our attributes will all be defined by numeric types.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    # - The (x,y,z) point on the surface defined according to the camera\'s frame of reference.\n\
    #   &gt; (!) Important: the \'pointCamera\' string relates to the samplerInfo maya node.\n\
    #   &gt; This value is supplied by the render sampler at computation time.\n\
    depthShader.surfacePointAttribute = numericAttributeFn.createPoint(\'pointCamera\', \'p\')\n\
    numericAttributeFn.storable = False\n\
    numericAttributeFn.hidden = True\n\
    depthShader.addAttribute( depthShader.surfacePointAttribute )\n\
    \n\
    # - The \'near\' distance, i.e. the minimum distance threshold from the camera after which the \n\
    #   pixel\'s color is modified by the depth of the point.\n\
    #   &gt; This value can be defined by the user, and is storable.\n\
    global defaultNearDistance, defaultFarDistance\n\
    depthShader.nearDistanceAttribute = numericAttributeFn.create( \'nearDistance\', \'nd\', \n\
                                                                   <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultNearDistance )\n\
    numericAttributeFn.storable =  True\n\
    numericAttributeFn.setMin(0.0)\n\
    numericAttributeFn.setMax( defaultFarDistance )\n\
    depthShader.addAttribute( depthShader.nearDistanceAttribute )\n\
    \n\
    # - The \'far\' distance, i.e. the minimum distance threshold from the camera before which the\n\
    #   pixel\'s color is modified by the depth of the point.\n\
    #   &gt; This value can be defined by the user, and is storable.\n\
    depthShader.farDistanceAttribute = numericAttributeFn.create( \'farDistance\', \'fd\', \n\
                                                                  <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultFarDistance )\n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.setMin( defaultFarDistance + 0.1 ) # Add an epsilon value of 0.1 to avoid near distance overlap.\n\
    numericAttributeFn.setMax( 3 * defaultFarDistance )\n\
    depthShader.addAttribute( depthShader.farDistanceAttribute )\n\
    \n\
    # - The \'near\' color.\n\
    #   &gt; This value can be defined by the user using a color picker, and is storable.\n\
    global defaultNearColor\n\
    depthShader.nearColorAttribute = numericAttributeFn.createColor( \'nearColor\', \'nc\' )\n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.default = ( defaultNearColor[0], defaultNearColor[1], defaultNearColor[2] )\n\
    depthShader.addAttribute( depthShader.nearColorAttribute )\n\
    \n\
    # - The \'far\' color.\n\
    #   &gt; This value can be defined by the user using a color picker, and is storable.\n\
    global defaultFarColor\n\
    depthShader.farColorAttribute = numericAttributeFn.createColor( \'farColor\', \'fc\' )\n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.default = ( defaultFarColor[0], defaultFarColor[1], defaultFarColor[2] )\n\
    depthShader.addAttribute( depthShader.farColorAttribute )\n\
    \n\
    # - The gamma value, or roll-off bias, which will affect how the color is interpolated between\n\
    #   the near and far colors.\n\
    #   &gt; This value can be defined by the user using a slider, and is storable.\n\
    global defaultGamma, minGamma, maxGamma\n\
    depthShader.gammaAttribute = numericAttributeFn.create( \'gamma\', \'g\', \n\
                                                            <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultGamma )\n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.setMin( minGamma )\n\
    numericAttributeFn.setMax( maxGamma )\n\
    depthShader.addAttribute( depthShader.gammaAttribute )\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================    \n\
    # - The pixel color output.\n\
    #   &gt; This value is computed in our depthShader.compute() method, and should not be stored.\n\
    depthShader.outColorAttribute = numericAttributeFn.createColor( \'outColor\', \'oc\')\n\
    numericAttributeFn.storable = False \n\
    numericAttributeFn.writable = False \n\
    numericAttributeFn.readable = True \n\
    numericAttributeFn.hidden = False \n\
    depthShader.addAttribute( depthShader.outColorAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    #  - All the input attributes affect the computation of the pixel color output (outColor).\n\
    depthShader.attributeAffects( depthShader.surfacePointAttribute, depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.nearDistanceAttribute, depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.farDistanceAttribute,  depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.nearColorAttribute,    depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.farColorAttribute,     depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.gammaAttribute,        depthShader.outColorAttribute )\n\
\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initializes the plug-in. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator, \n\
                    nodeInitializer, OpenMaya.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( \"Failed to register node: \" + kPluginNodeName )\n\
        raise\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Unitializes the plug-in. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( \"Failed to deregister node: \" + kPluginNodeName )\n\
        raise\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
import random\n\
\n\
# Load our plug-in.\n\
cmds.loadPlugin( \'pyDepthShader.py\' )\n\
\n\
# Clear the scene.\n\
cmds.file( new=True, force=True )\n\
\n\
# Create an instance of our depth shader.\n\
depthShaderName = cmds.shadingNode( \'pyMyDepthShader\', asUtility=True )\n\
cmds.setAttr( depthShaderName + \'.gamma\', 1.4 )\n\
cmds.setAttr( depthShaderName + \'.farColor\', 0, 0.43, 1, type=\'double3\' )\n\
\n\
# Create a surface shader to which we will attach our depth shader.\n\
surfaceShaderName = cmds.shadingNode( \'surfaceShader\', asShader=True )\n\
cmds.connectAttr( depthShaderName + \'.outColor\', surfaceShaderName + \'.outColor\', force=True )\n\
\n\
# Create a shading group to tie everything together.\n\
shadingGroupName = cmds.sets( name=\'surfaceShader1SG\', empty=True, noSurfaceShader=True, renderable=True )\n\
cmds.connectAttr( surfaceShaderName + \'.outColor\', shadingGroupName + \'.surfaceShader\', force=True )\n\
\n\
# Create a bunch cubes pseudo-randomly placed according to a seeded random number generator.\n\
numCubes = 50\n\
positionRange = 14\n\
\n\
randomSeed = 5\n\
random.seed( randomSeed )\n\
\n\
for i in range( 0, numCubes ):\n\
    # Create a new cube.\n\
    newCubeName = cmds.polyCube( w=2, h=2, d=2 )\n\
    \n\
    # Move the cube somewhere near the grid.\n\
    cmds.move( random.randint( -positionRange, positionRange ), # x\n\
               random.randint( -positionRange, positionRange ), # y\n\
               random.randint( -positionRange, positionRange ), # z\n\
               newCubeName )\n\
    \n\
    # Rotate the cube along all three axes.\n\
    cmds.rotate( random.randint( 0, 360 ), # x axis\n\
                 random.randint( 0, 360 ), # y axis\n\
                 random.randint( 0, 360 ), # z axis\n\
                 newCubeName )\n\
\n\
    # Assign the cube we have created to our surface (depth) shader.\n\
    cmds.sets( newCubeName, e=True, forceElement=shadingGroupName )\n\
\n\
# Render the current view.\n\
cmds.render()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_E8C5E178C79544AF82ADB28BD58AF323\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-550F006A-3C30-4A1C-853B-AC06E24E7E02\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># depthShader.py\n\
\n\
import sys\n\
import math\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
\n\
# Plug-in information:\n\
kPluginNodeName = \'myDepthShader\'\n\
kPluginNodeClassify = \'utility/general\'\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>(0x870FE)\n\
\n\
# Default attribute values\n\
defaultNearDistance = 20.0\n\
defaultFarDistance  = 70.0\n\
defaultNearColor    = (1.0, 1.0, 1.0) # (r,g,b) white\n\
defaultFarColor     = (0.0, 0.0, 0.0) # (r,g,b) black\n\
defaultGamma        = 1.0\n\
minGamma            = 0.1\n\
maxGamma            = 5.0\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class depthShader(OpenMayaMPx.MPxNode):\n\
    \'\'\' Creates a depth shader which renders in Maya\'s software renderer. \'\'\'\n\
    # Define the static variables to which we will assign the node\'s attributes\n\
    # in nodeInitializer() defined below.\n\
    surfacePointAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    nearDistanceAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    farDistanceAttribute  = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    nearColorAttribute    = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    farColorAttribute     = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    gammaAttribute        = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()    \n\
    outColorAttribute     = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
    \n\
    def compute(self, pPlug, pDataBlock):\n\
        \'\'\' \n\
        Node computation method. \n\
          - pDataBlock contains the data on which we will base our computations. \n\
          - pPlug is a connection point related to one of our node attributes (either an input or an output). \n\
        \'\'\'\n\
        if ( pPlug == depthShader.outColorAttribute ):\n\
            \n\
            # Get the data handles corresponding to your attributes among the values in the data block.\n\
            surfacePointDataHandle = pDataBlock.inputValue( depthShader.surfacePointAttribute )\n\
            nearDistanceDataHandle = pDataBlock.inputValue( depthShader.nearDistanceAttribute )\n\
            farDistanceDataHandle  = pDataBlock.inputValue( depthShader.farDistanceAttribute )\n\
            nearColorDataHandle    = pDataBlock.inputValue( depthShader.nearColorAttribute )\n\
            farColorDataHandle     = pDataBlock.inputValue( depthShader.farColorAttribute )\n\
            gammaDataHandle        = pDataBlock.inputValue( depthShader.gammaAttribute )\n\
            \n\
            # Obtain the (x,y,z) location of the currently rendered point in camera coordinates.\n\
            surfacePoint = surfacePointDataHandle.asFloatVector()\n\
            \n\
            # Since the camera is looking along its negative Z axis (the Y axis is \n\
            # the up vector), we must take the absolute value of the Z coordinate\n\
            # to obtain the point\'s depth.\n\
            depth = abs(surfacePoint.z) \n\
            \n\
            # Get the actual near and far threshold values.\n\
            nearValue = nearDistanceDataHandle.asFloat()\n\
            farValue = farDistanceDataHandle.asFloat()\n\
            \n\
            # Find the proportion of depth between the near and far values.\n\
            if( (farValue - nearValue) == 0):\n\
                # Avoid a division by zero if the near and far values somehow have the same value.\n\
                depthProportion = 0\n\
            else:\n\
                depthProportion = (depth - nearValue) / (farValue - nearValue)\n\
            \n\
            # Clamp the depthProportion value in the interval [0.0, 1.0]\n\
            depthProportion = max(0, min( depthProportion, 1.0 ) )\n\
            \n\
            # Modify the depth proportion using the gamma roll-off bias.\n\
            gammaValue = gammaDataHandle.asFloat()\n\
            depthProportion = math.pow(depthProportion, gammaValue)\n\
            \n\
            # Linearly interpolate the output color based on the depth proportion.\n\
            outColor = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFloatVector</a>(0, 0, 0)\n\
            nearColor = nearColorDataHandle.asFloatVector()\n\
            farColor = farColorDataHandle.asFloatVector()\n\
            \n\
            outColor.x = nearColor.x + ( ( farColor.x - nearColor.x ) * depthProportion )\n\
            outColor.y = nearColor.y + ( ( farColor.y - nearColor.y ) * depthProportion )\n\
            outColor.z = nearColor.z + ( ( farColor.z - nearColor.z ) * depthProportion )\n\
            \n\
            # Write to the output data.\n\
            outColorDataHandle = pDataBlock.outputValue( depthShader.outColorAttribute )\n\
            outColorDataHandle.setMFloatVector( outColor )\n\
            outColorDataHandle.setClean()\n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    \'\'\' \n\
    Creates an instance of our node plug-in and delivers it to Maya as a pointer. \n\
    \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( depthShader() )\n\
\n\
def nodeInitializer():\n\
    \'\'\' \n\
    Defines the set of attributes for our node. The attributes\n\
    declared in this function are assigned as static members to our\n\
    depthShader class. Instances of depthShader will use these attributes\n\
    to create plugs for use in the compute() method.\n\
    \'\'\'\n\
    # Create a numeric attribute function set, since our attributes will all be defined by numeric types.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    # - The (x,y,z) point on the surface defined according to the camera\'s frame of reference.\n\
    #   &gt; (!) Important: the \'pointCamera\' string relates to the samplerInfo maya node.\n\
    #   &gt; This value is supplied by the render sampler at computation time.\n\
    depthShader.surfacePointAttribute = numericAttributeFn.createPoint(\'pointCamera\', \'p\')\n\
    numericAttributeFn.setStorable(False)\n\
    numericAttributeFn.setHidden(True)\n\
    depthShader.addAttribute( depthShader.surfacePointAttribute )\n\
    \n\
    # - The \'near\' distance, i.e. the minimum distance threshold from the camera after which the \n\
    #   pixel\'s color is modified by the depth of the point.\n\
    #   &gt; This value can be defined by the user, and is storable.\n\
    global defaultNearDistance, defaultFarDistance\n\
    depthShader.nearDistanceAttribute = numericAttributeFn.create( \'nearDistance\', \'nd\', \n\
                                                                   <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultNearDistance )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setMin( 0.0 )\n\
    numericAttributeFn.setMax( defaultFarDistance )\n\
    depthShader.addAttribute( depthShader.nearDistanceAttribute )\n\
    \n\
    # - The \'far\' distance, i.e. the minimum distance threshold from the camera before which the\n\
    #   pixel\'s color is modified by the depth of the point.\n\
    #   &gt; This value can be defined by the user, and is storable.\n\
    depthShader.farDistanceAttribute = numericAttributeFn.create( \'farDistance\', \'fd\', \n\
                                                                  <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultFarDistance )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setMin( defaultFarDistance + 0.1 ) # Add an epsilon value of 0.1 to avoid near distance overlap.\n\
    numericAttributeFn.setMax( 3 * defaultFarDistance )\n\
    depthShader.addAttribute( depthShader.farDistanceAttribute )\n\
    \n\
    # - The \'near\' color.\n\
    #   &gt; This value can be defined by the user using a color picker, and is storable.\n\
    global defaultNearColor\n\
    depthShader.nearColorAttribute = numericAttributeFn.createColor( \'nearColor\', \'nc\' )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setDefault( defaultNearColor[0], defaultNearColor[1], defaultNearColor[2] )\n\
    depthShader.addAttribute( depthShader.nearColorAttribute )\n\
    \n\
    # - The \'far\' color.\n\
    #   &gt; This value can be defined by the user using a color picker, and is storable.\n\
    global defaultFarColor\n\
    depthShader.farColorAttribute = numericAttributeFn.createColor( \'farColor\', \'fc\' )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setDefault( defaultFarColor[0], defaultFarColor[1], defaultFarColor[2] )\n\
    depthShader.addAttribute( depthShader.farColorAttribute )\n\
    \n\
    # - The gamma value, or roll-off bias, which will affect how the color is interpolated between\n\
    #   the near and far colors.\n\
    #   &gt; This value can be defined by the user using a slider, and is storable.\n\
    global defaultGamma, minGamma, maxGamma\n\
    depthShader.gammaAttribute = numericAttributeFn.create( \'gamma\', \'g\', \n\
                                                            <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, defaultGamma )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setMin( minGamma )\n\
    numericAttributeFn.setMax( maxGamma )\n\
    depthShader.addAttribute( depthShader.gammaAttribute )\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================    \n\
    # - The pixel color output.\n\
    #   &gt; This value is computed in our depthShader.compute() method, and should not be stored.\n\
    depthShader.outColorAttribute = numericAttributeFn.createColor( \'outColor\', \'oc\')\n\
    numericAttributeFn.setStorable( False )\n\
    numericAttributeFn.setWritable( False )\n\
    numericAttributeFn.setReadable( True )\n\
    numericAttributeFn.setHidden( False )\n\
    depthShader.addAttribute( depthShader.outColorAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    #  - All the input attributes affect the computation of the pixel color output (outColor).\n\
    depthShader.attributeAffects( depthShader.surfacePointAttribute, depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.nearDistanceAttribute, depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.farDistanceAttribute,  depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.nearColorAttribute,    depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.farColorAttribute,     depthShader.outColorAttribute )\n\
    depthShader.attributeAffects( depthShader.gammaAttribute,        depthShader.outColorAttribute )\n\
\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initializes the plug-in. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator, \n\
                    nodeInitializer, OpenMayaMPx.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( \"Failed to register node: \" + kPluginNodeName )\n\
        raise\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Unitializes the plug-in. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( \"Failed to deregister node: \" + kPluginNodeName )\n\
        raise\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
import random\n\
\n\
# Load our plug-in.\n\
cmds.loadPlugin( \'depthShader.py\' )\n\
\n\
# Clear the scene.\n\
cmds.file( new=True, force=True )\n\
\n\
# Create an instance of our depth shader.\n\
depthShaderName = cmds.shadingNode( \'myDepthShader\', asUtility=True )\n\
cmds.setAttr( depthShaderName + \'.gamma\', 1.4 )\n\
cmds.setAttr( depthShaderName + \'.farColor\', 0, 0.43, 1, type=\'double3\' )\n\
\n\
# Create a surface shader to which we will attach our depth shader.\n\
surfaceShaderName = cmds.shadingNode( \'surfaceShader\', asShader=True )\n\
cmds.connectAttr( depthShaderName + \'.outColor\', surfaceShaderName + \'.outColor\', force=True )\n\
\n\
# Create a shading group to tie everything together.\n\
shadingGroupName = cmds.sets( name=\'surfaceShader1SG\', empty=True, noSurfaceShader=True, renderable=True )\n\
cmds.connectAttr( surfaceShaderName + \'.outColor\', shadingGroupName + \'.surfaceShader\', force=True )\n\
\n\
# Create a bunch cubes pseudo-randomly placed according to a seeded random number generator.\n\
numCubes = 50\n\
positionRange = 14\n\
\n\
randomSeed = 5\n\
random.seed( randomSeed )\n\
\n\
for i in range( 0, numCubes ):\n\
    # Create a new cube.\n\
    newCubeName = cmds.polyCube( w=2, h=2, d=2 )\n\
    \n\
    # Move the cube somewhere near the grid.\n\
    cmds.move( random.randint( -positionRange, positionRange ), # x\n\
               random.randint( -positionRange, positionRange ), # y\n\
               random.randint( -positionRange, positionRange ), # z\n\
               newCubeName )\n\
    \n\
    # Rotate the cube along all three axes.\n\
    cmds.rotate( random.randint( 0, 360 ), # x axis\n\
                 random.randint( 0, 360 ), # y axis\n\
                 random.randint( 0, 360 ), # z axis\n\
                 newCubeName )\n\
\n\
    # Assign the cube we have created to our surface (depth) shader.\n\
    cmds.sets( newCubeName, e=True, forceElement=shadingGroupName )\n\
\n\
# Render the current view.\n\
cmds.render()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";