var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-827DCBD9-52FC-4963-A2C0-56A3211BB096\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Write fragments and fragment graphs to render to the viewport</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-827DCBD9-52FC-4963-A2C0-56A3211BB096\"></a><div class=\"head\">\n\
            <h1>Write fragments and fragment graphs to render to the viewport </h1>\n\
         </div><a name=\"FIG_901137EBC3044454B3B21D8190C64261\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-57E9DA6F-DB97-48FB-859F-5FA7A7471DF8-low.png\"></div>\n\
         <div class=\"section\"><a name=\"SECTION_ACA7AE27995F464286A2494A9A91FB99\"></a> \n\
            <h2><a name=\"GUID-B88EF8BB-2295-4584-8949-A72AD4348595\"></a>Introduction\n\
            </h2> \n\
            <p>A fragment is a procedure or function definition in a high level language. It has\n\
               typed inputs and outputs, and executes some procedure on the inputs to produce the\n\
               output(s). \n\
               		\n\
            </p> \n\
            <p>You can write shading fragments, or you can write script fragments that execute a\n\
               series of commands to set up parameters and states and clear or render to various\n\
               targets. \n\
               		\n\
            </p> \n\
            <p>Fragments may then be connected into fragment graphs. A fragment graph does not contain\n\
               commands; instead, it instantiates a set of fragments and describes the connections\n\
               between them. \n\
               		\n\
            </p> \n\
            <p>A single script fragment or fragment graph can be stored in a .xml file. \n\
               		\n\
            </p> \n\
            <p>A set of script fragment and fragment graph xml files are provided with the Maya installation\n\
               at the \n\
               		  <span class=\"code\" translate=\"no\">bin/ScriptFragment</span> directory of your installation directory. These fragment and fragment graphs are\n\
               used to render to Viewport 2.0. \n\
               		\n\
            </p> \n\
            <p><span class=\"code\" translate=\"no\">Default.xml</span> is the main fragment graph that describes how Maya renders in Viewport 2.0. When\n\
               this fragment graph is executed, the scene is displayed in the viewport. \n\
               		\n\
            </p> \n\
            <p>It connects various fragments and fragment graphs such as Maya_3d_Renderer, which\n\
               connects fragment graphs such as HoldOutPasses and Maya_PostEffects, which connects\n\
               fragments and fragment graphs such as the mayaUIDrawPass and Maya_SSAO, and so forth.\n\
               \n\
               		\n\
            </p> \n\
            <p>These xml files serve as examples of how to write your own script fragment and fragment\n\
               graphs for a fragment renderer. \n\
               		\n\
            </p> \n\
            <p>When creating your own fragment renderer, you can re-use existing Maya fragments,\n\
               and only write the xml for the fragments that you want to customize. For example,\n\
               to create your own custom motion blur pass, you can write a motion blur fragment and\n\
               combine it with existing Maya fragments. \n\
               		\n\
            </p> \n\
            <p>One way to accomplish this would be to do as follows: \n\
               		\n\
            </p> <a name=\"OL_50F1397C123944A4B53BFB2C536CF8BF\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Copy the existing Maya fragment/fragment graph .xml files into a new folder. \n\
                  		  \n\
               </li>\n\
               <li>Modify the fragment/fragment graph that you want to customize and rename it. \n\
                  			 \n\
                  <div><a name=\"GUID-E97B64C3-2912-48FE-9895-D14B9B5B3FD0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Directly modifying the files in \n\
                        				<span class=\"code\" translate=\"no\">bin/ScriptFragment</span> is not recommended, as you may inadvertently corrupt Maya. It is therefore recommended\n\
                        that the fragment files first be copied into a new folder. \n\
                        			 \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li>Modify the main fragment graph (<span class=\"code\" translate=\"no\">default.xml</span>) to point to your modified fragment/fragment graph (from step 2), and give the main\n\
                  fragment graph a new name. \n\
                  		  \n\
               </li>\n\
            </ol> \n\
            <p>Some procedurals cannot be easily represented as script fragments, and are provided\n\
               as hardcoded C++ procedural fragments with Maya. You can combine C++ procedural fragments\n\
               with script fragments in your fragment graph. \n\
               		\n\
            </p> \n\
            <div><a name=\"GUID-A44FEA12-1849-488D-BABA-2E99BB4949BF\"></a><div class=\"note-tip\"><span class=\"label label-target-language\">TIP:</span> \n\
                  <p>To reproduce Maya\'s renderer, first initialize an \n\
                     			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderOverride</a></span> with a list of operations such as the following: \n\
                     		  \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">class FragmentRenderOverride(omr.MRenderOverride):\n\
\n\
    def __init__(self, name):\n\
        self.operatioIndex = 0\n\
        self.operations =  [omr.MSceneRender(\"myRendererSameAsMaya\", “default”),\n\
                           omr.MHUDRender(),\n\
                           omr.MPresentTarget(\"present\")]</pre></div> \n\
                  <p>Where \n\
                     			 <em class=\"mild\">“default”</em> is the name of the render fragment that Maya uses when not overridden. \n\
                     			 <span class=\"code\" translate=\"no\">default.xml</span> can be found in the \n\
                     			 <span class=\"code\" translate=\"no\">bin/ScriptFragment</span> folder of your Maya installation directory. \n\
                     		  \n\
                  </p> \n\
                  <p>Default only draws the beauty pass and does not include the drawing of UI, shadow\n\
                     maps, HUD, and so forth that are part of \n\
                     			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneRender</a></span>. \n\
                     		  \n\
                  </p> \n\
               </div>\n\
            </div>  \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_988B64FD78654EC79EC24FBAA7A9BD23\"></a> \n\
            <h2><a name=\"GUID-63A1E709-77E0-4EFA-AC85-F9657629DED3\"></a>API classes and interfaces\n\
            </h2> \n\
            <p>API entry points for creating a fragment renderer are as follows. See the \n\
               		  <em class=\"mild\">viewRenderOverrideFromFragments</em> plug-in in the Developer Kit and \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-06FE4581-2115-4414-B17C-E6559F269615.htm\">Create a fragment renderer plug-in example</a></span> for example usage of these interfaces. \n\
               		\n\
            </p> <a name=\"UL_6FC6D025A20F465B877126434E905E28\"></a><ul>\n\
               <li>Call \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::getFragmentManager()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a0f42783e8eee6f472d6bbb2acb6b2f2d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderer::getFragmentManager()</a></span> to access the Fragment Manager, and call \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager::addFragmentGraphFromFile()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html#a222716cf7cc5d67a80ca5be267503813&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFragmentManager::addFragmentGraphFromFile()</a></span> to register a script fragment or fragment graph. \n\
                  		  \n\
               </li>\n\
               <li>Create your scene render using this \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneRender</a></span> constructor that allows you to provide the name of the fragment with which you want\n\
                  to render the scene. \n\
                  			 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">MSceneRender (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;name, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;fragmentName)</pre></div> \n\
               </li>\n\
               <li>Initialize an \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderOverride</a></span> with a list of \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderOperation</a></span>s, one of which is the custom render operation, derived from \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneRender</a></span>. \n\
                  		  \n\
               </li>\n\
               <li>Register it by calling \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::registerOverride()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ae677d98e2300e2f9c69abb576539ac37&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderer::registerOverride()</a></span>. \n\
                  		  \n\
               </li>\n\
               <li>To get or set render parameters: \n\
                  			 <a name=\"UL_8E3B5E8A93164897810FF41E293B823F\"></a><ul>\n\
                     <li>Call \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::getParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a426c26adb287500c03beeabeee48851c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneRender::getParameters()</a></span> to return a pointer to \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderParameters</a></span>, which is a block of render input parameters used to control the renderer \n\
                        				\n\
                     </li>\n\
                     <li>Call \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters::setParameter()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html#aa17e2c9a17b86064950103066fa307ef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderParameters::setParameter()</a></span> to pass the values to the render fragment used by the custom \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSceneRender</a></span>. \n\
                        				\n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li> \n\
                  <p>(Optional) Derive from the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderScriptCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_script_callback.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderScriptCallback</a></span> class to create a callback function that can be registered and called from your script\n\
                     fragment \n\
                     				<span class=\"code\" translate=\"no\">.xml</span>. Implement the \n\
                     				<span class=\"code\" translate=\"no\">execute()</span> function which allows you to obtain the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderParameters</a></span> from the current renderer graph and three optional values coming from the script.\n\
                     Use this method to compute any desired behavior and call \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters::setParameter()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html#aa17e2c9a17b86064950103066fa307ef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderParameters::setParameter()</a></span> to pass the results back to the script or to other connected fragments in the graph.\n\
                     See the \n\
                     				<span class=\"char_link\"><a href=\"#!/url=./files/GUID-5888DEB3-2B60-4B2D-B729-8AD03E0C58FA.htm#SECTION_706B0491C62340B4A96651439A5D6598\">Call</a></span> command in the \n\
                     				<span class=\"char_link\"><a href=\"#!/url=./files/GUID-5888DEB3-2B60-4B2D-B729-8AD03E0C58FA.htm\">Script fragment commands</a></span> topic for more information. \n\
                     			 \n\
                  </p> \n\
                  <p>The \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::registerScriptCallback()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ae60e50cef7a7b5b5a006a74fab479c11&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderer::registerScriptCallback()</a></span> and \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::deregisterScriptCallback()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a8db004785e17022a463c4a195d50c168&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderer::deregisterScriptCallback()</a></span> interfaces allow you to register/deregister an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderScriptCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_script_callback.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderScriptCallback</a></span>. After registering, this callback can be called using the \n\
                     				<span class=\"code\" translate=\"no\">Call</span> command in your script fragment .xml. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4D486A866D7F4876B69AABBB4296A0BF\"></a> \n\
            <h2><a name=\"GUID-1392CB5D-9213-4335-BAC2-AB13569C815B\"></a>Fragment and fragment graph XML definition\n\
            </h2> \n\
            <div class=\"section\"><a name=\"SECTION_1E5DE6C655054720BFDC3CCC38F68E6E\"></a> \n\
               <h3><a name=\"GUID-61C1B579-6764-4194-8024-0213F8F6842F\"></a>Parts of the fragment description\n\
               </h3> \n\
               <p>Refer to \n\
                  			 <span class=\"code\" translate=\"no\">maya_DepthPrePass.xml</span> for an example. \n\
                  		  \n\
               </p> \n\
               <p>All fragments are contained within the compound element \n\
                  			 <em class=\"mild\">fragment</em>. \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment  uiName=\"maya_DepthPrePass\" name=\"maya_DepthPrePass\" type=\"sceneEffect\" class=\"ScriptFragment\" version=\"1.0\" feature_level=\"30\" &gt;</pre></div> <a name=\"UL_A2ECC0F7470847F188F3B535CF083CEC\"></a><ul>\n\
                  <li>Set the \n\
                     				<em class=\"mild\">name</em> attribute to the internal name of the fragment. \n\
                     			 \n\
                  </li>\n\
                  <li>You can set the \n\
                     				<em class=\"mild\">uiName</em> to be the same as its internal name, or provide it with an external name. \n\
                     			 \n\
                  </li>\n\
                  <li>Set the \n\
                     				<em class=\"mild\">type</em> attribute to \n\
                     				<em class=\"strong\">sceneEffect</em>. \n\
                     			 \n\
                  </li>\n\
                  <li>The \n\
                     				<em class=\"mild\">class</em> attribute must be set to \n\
                     				<em class=\"strong\">ScriptFrament</em> for fragments (and FragmentGraph for fragment graphs.) \n\
                     			 \n\
                  </li>\n\
                  <li>Set the \n\
                     				<em class=\"mild\">version</em> attribute to identify changes between releases. In most cases, you can set this value\n\
                     to 1.0, as in this example. \n\
                     			 \n\
                  </li>\n\
                  <li>Set the \n\
                     				<em class=\"mild\">feature_level</em> attribute to the highest feature level support required by the effects and features\n\
                     used in the passes. For example, feature_level 30 is equivalent to DirectX 10. In\n\
                     most cases, setting this value to 30 as in this example is sufficient. \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
               <p>The fragment definition also contains the following elements: \n\
                  		  \n\
               </p> <a name=\"UL_493CBC5FAC5944D784351FB28030257C\"></a><ul>\n\
                  <li>An optional \n\
                     				<em class=\"mild\">description</em> element, where a description is wrapped in a CDATA block \n\
                     				\n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;description&gt;\n\
    &lt;![CDATA[\n\
    depth pre-pass: make depthStencil &amp; linear, readable opaque depth texture]]&gt;\n\
&lt;/description&gt;</pre></div> \n\
                  </li>\n\
                  <li> \n\
                     <p>A required set of input parameters called \n\
                        				  <em class=\"mild\">properties</em>. \n\
                        				\n\
                     </p> \n\
                     <p>Use the format \n\
                        				  <span class=\"code\" translate=\"no\">&lt;type name =\"myParam\"&gt;</span>, where \n\
                        				  <em class=\"mild\">type</em> is the type of the parameter (for example, int, float4, and so forth), and \n\
                        				  <em class=\"mild\">name</em> is the required name of the parameter (unique within the set). \n\
                        				\n\
                     </p> \n\
                     <p>This may include pre-defined, known inputs in Maya; for example, preOpaqueUIList,\n\
                        transparentBitmapsList, camera, viewport, and so forth. \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;properties&gt;\n\
    &lt;countedObject  name=\"preOpaqueUIList\" /&gt;\n\
    ....\n\
&lt;/properties&gt;</pre></div> \n\
                  </li>\n\
                  <li>A set of initial \n\
                     				<em class=\"mild\">values</em> for parameters without input connections \n\
                     				\n\
                     <p>To define parameters with an initial value, in the value element, use the format:\n\
                        \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;type name =\"myParam\" value =\"…\" /&gt; </pre></div> \n\
                     <p>The exact format of the value string is determined by the type of the parameter. Multiple\n\
                        values are given using comma-separated lists; for example, “0,1,3” would match an\n\
                        int3 or float3 parameter. \n\
                        				\n\
                     </p> \n\
                     <p>All attributes in the fragment graph that share the same name are initialized with\n\
                        these values. \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;values&gt;\n\
    &lt;float4 name=\"viewport\" value=\"0.000000,0.000000,1.000000,1.000000\"  /&gt;\n\
    ....\n\
&lt;/values&gt;</pre></div> \n\
                  </li>\n\
                  <li>A set of output parameters called \n\
                     				<em class=\"mild\">outputs</em>: \n\
                     				\n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;outputs&gt;\n\
    &lt;target  name=\"depthOut\" /&gt;\n\
    &lt;target  name=\"opaquedepthtexture\" /&gt;\n\
&lt;/outputs&gt;</pre></div> \n\
                  </li>\n\
                  <li>An implementation element containing a list of commands. Set \n\
                     				<em class=\"mild\">render</em> to \n\
                     				<em class=\"strong\">OGS</em> and \n\
                     				<em class=\"mild\">language</em> to \n\
                     				<em class=\"strong\">ScriptInterpreter</em>. \n\
                     				\n\
                     <p>Each command is defined by a single element of the form: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;command     value=\"theValue\" /&gt;</pre></div> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;implementation render=\"OGS\" language=\"ScriptInterpreter\" version=\"0.1\" &gt;\n\
    &lt;scriptCommands&gt;\n\
        &lt;AcquireTarget name=\"localZ\" format=\"EFORMAT_R32_FLOAT\" size=\"@finalDesc.size\" relSize=\"1.0,1.0\" msaa=\"0\" /&gt;\n\
        ....\n\
    &lt;/scriptCommands&gt;\n\
&lt;/implmentation&gt;</pre></div> \n\
                     <p>See \n\
                        				  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-5888DEB3-2B60-4B2D-B729-8AD03E0C58FA.htm\">Script fragment commands</a></span> for a list of available commands. \n\
                        				\n\
                     </p> \n\
                     <p>When listing commands, use the symbol @ to indicate that the value should be obtained\n\
                        from a parameter instead of being set by a local value. For example, in the code snippet\n\
                        above, the value is obtained from the finalDesc parameter. \n\
                        				\n\
                     </p>  \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_EF660E9875A34EC18BEB202324293E02\"></a> \n\
               <h3><a name=\"GUID-C129328D-F7EE-4510-86AB-FCBA97DF2A10\"></a>Parts of a fragment graph definition\n\
               </h3> \n\
               <p>As described earlier, various script fragments and fragment graphs can be connected\n\
                  to one another to form a single fragment graph. \n\
                  		  \n\
               </p> \n\
               <p>Refer to \n\
                  			 <span class=\"code\" translate=\"no\">Maya_PostEffects.xml</span> for an example. \n\
                  		  \n\
               </p> \n\
               <p>All fragments are contained within the compound element \n\
                  			 <em class=\"mild\">fragment_graph</em> as follows: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment_graph  name=\"Maya_PostEffects\" ref=\"Maya_PostEffects\" class=\"FragmentGraph\" version=\"1.0\" feature_level=\"0\" &gt;</pre></div> <a name=\"UL_C9EB399DB1B64678837DE52FFD53A04C\"></a><ul>\n\
                  <li> \n\
                     <p>Set the \n\
                        				  <em class=\"mild\">ref</em> attribute to the internal name of the fragment graph. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p>You can set the \n\
                        				  <em class=\"mild\">name</em> attribute to be the same as the internal name, or provide it with an external name.\n\
                        \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p>The \n\
                        				  <em class=\"mild\">class</em> attribute must be set to \n\
                        				  <em class=\"strong\">FragmentGraph</em>. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
               <p>The fragment_graph definition also contains the following elements: \n\
                  		  \n\
               </p> <a name=\"UL_8768996E05F74BB0AF2CA73E9BA1A97D\"></a><ul>\n\
                  <li><em class=\"mild\">Fragments</em> \n\
                     <p>List all the fragments contained in this graph; the order of the listing is not important.\n\
                        \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragments&gt;\n\
    &lt;fragment_ref name=\"Maya_UI\" ref=\"mayaUIDrawPass\" /&gt;\n\
    ....\n\
&lt;/fragments&gt;</pre></div> \n\
                     <p>Set the \n\
                        				  <em class=\"mild\">ref</em> attribute to the internal/default name of the fragment; that is, the name defined\n\
                        by the \n\
                        				  <em class=\"mild\">name</em> attribute in the \n\
                        				  <em class=\"mild\">fragment</em> element in the XML file. \n\
                        				\n\
                     </p> \n\
                     <p>You can set the \n\
                        				  <em class=\"mild\">name</em> attribute to be the same as the \n\
                        				  <em class=\"mild\">ref</em> attribute. Alternatively, you can set it to a different name for use in different\n\
                        instances. This way, if the same attribute is used in two different passes, the attribute\n\
                        can have different connections in the two passes. \n\
                        				\n\
                     </p> \n\
                     <p>For example, refer to \n\
                        				  <span class=\"code\" translate=\"no\">Maya_PostEffects.xml</span>, where the \n\
                        				  <span class=\"code\" translate=\"no\">Maya_PostEffects</span> fragment graph includes the graph \n\
                        				  <span class=\"code\" translate=\"no\">Maya_SSAO</span>: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment_ref name=\"Maya_SSAO\" ref=\"Maya_SSAO\" /&gt;</pre></div> \n\
                     <p>It then connects the \n\
                        				  <span class=\"code\" translate=\"no\">Maya_SSAO.res</span> to \n\
                        				  <span class=\"code\" translate=\"no\">Maya_MotionBlur.input</span>: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;connect from=\"Maya_SSAO.res\" to=\"Maya_MotionBlur.input\" name=\"input\" /&gt;</pre></div> \n\
                     <p>To create different connections to or from \n\
                        				  <span class=\"code\" translate=\"no\">Maya_SSAO</span> in another pass or fragment graph, you can instead do the following: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment_ref name=\"Maya_SSAO_instance1\" ref=\"Maya_SSAO\" /&gt;</pre></div> \n\
                     <p>Then connect it as follows: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;connect from=\"Maya_SSAO_instance1.res\" to=\"Maya_MotionBlur.input\" name=\"input\" /&gt;\n\
</pre></div> \n\
                     <p><span class=\"code\" translate=\"no\">Maya_MotionBlur.input</span> can now receive a different input in other fragment graphs. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li><em class=\"mild\">Connections</em> \n\
                     <p>Specify all the connections between fragments. Each connect element specifies one\n\
                        output, \n\
                        				  <em class=\"mild\">from</em>, connected to one property input, \n\
                        				  <em class=\"mild\">to</em>. \n\
                        				\n\
                     </p> \n\
                     <p>Inputs may have only one connection, but outputs may have an arbitrary number. Unconnected\n\
                        inputs are either system supplied variables, matched by semantic, or become tweakable\n\
                        through the API. \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;connections&gt;\n\
    &lt;connect from=\"mayaPreUIScript.output\" to=\"Maya_UI.final\" name=\"final\" /&gt;\n\
    ....\n\
&lt;/connections&gt;</pre></div> \n\
                     <div><a name=\"GUID-97B24DB0-0587-4F62-B4A2-BB38AFF1D592\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span><span class=\"code\" translate=\"no\">final</span> denotes the buffer that results should be drawn into at the end of the operation.\n\
                           \n\
                           				\n\
                        </div>\n\
                     </div> \n\
                  </li>\n\
                  <li><em class=\"mild\">Properties</em> \n\
                     <p>List all unconnected input parameters by providing the name and attribute of its sub-fragment/fragment\n\
                        graph, and the external name that you want to use to represent it. \n\
                        				\n\
                     </p> \n\
                     <p>For example: \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;properties&gt;\n\
    &lt;float4  name=\"viewport\" ref=\"Maya_SSAO.viewport\" /&gt;\n\
    ....\n\
&lt;/properties&gt;</pre></div> \n\
                     <p>Maya_SSAO is a sub-fragment graph and its viewport attribute should be exposed using\n\
                        the alias \n\
                        				  <em class=\"mild\">viewport</em>. \n\
                        				\n\
                     </p> \n\
                  </li>\n\
                  <li><em class=\"mild\">Values</em> \n\
                     <p>Define initial values for unconnected input parameters. \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;values&gt;\n\
    &lt;float4 name=\"viewport\" value=\"0.000000,0.000000,1.000000,1.000000\"  /&gt;\n\
    ....\n\
&lt;/values&gt;</pre></div> \n\
                  </li>\n\
                  <li><em class=\"mild\">Outputs</em> \n\
                     <p>Specify the outputs here, and list the primary output first. \n\
                        				\n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;outputs&gt;\n\
    &lt;target  name=\"output\" ref=\"Maya_UI.output\" /&gt;\n\
&lt;/outputs&gt;</pre></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <p> </p> \n\
         </div>\n\
         <p>  </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-06FE4581-2115-4414-B17C-E6559F269615.htm\">Create a fragment renderer plug-in example</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-5888DEB3-2B60-4B2D-B729-8AD03E0C58FA.htm\">Script fragment commands</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";