var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-AABB9BB4-816F-4C7C-A526-69B0568E1587\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>The Dependency Graph</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AABB9BB4-816F-4C7C-A526-69B0568E1587\"></a><div class=\"head\">\n\
            <h1>The Dependency Graph</h1>\n\
         </div>\n\
         <p><a name=\"GUID-3173A414-D034-469D-B637-37D23F618A23\"></a>This topic summarizes the basic concepts of Maya\'s Dependency Graph. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_A194D8F7235546379E5203C7E4347CA1\"></a> \n\
            <h2><a name=\"GUID-4B0BA53C-A4C2-49AF-9051-0B1357B83667\"></a>What is the Dependency Graph?\n\
            </h2> \n\
            <p><a name=\"GUID-3C0E8D97-A99D-4825-85DE-710355BFEB23\"></a>The Dependency Graph is a network of <em class=\"mild\">nodes</em>, represented by instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>. The connection points of a node are known as <em class=\"mild\">plugs</em>, and are represented by instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>. A directed edge connects one node\'s output plug to another node\'s input plug. <span class=\"char_link\"><a href=\"#!/url=./files/GUID-AABB9BB4-816F-4C7C-A526-69B0568E1587.htm#SECTION_FB5361C1A77B434FA2D1E27507379638\">As we explain in greater detail below</a></span>, <em class=\"mild\">data blocks</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a></span>) sequentially visit the connected nodes in the graph, providing input to each node\'s\n\
               <span class=\"code\" translate=\"no\">compute()</span> function, and storing the resulting output. \n\
            </p> \n\
            <p><a name=\"GUID-3872863C-09F8-4457-850D-744C670279A7\"></a></p> <img src=\"images/GUID-BABA918B-5CAB-4B7C-BB8A-44F2F687027A-low.png\"> \n\
            <p><a name=\"GUID-9C2C612E-A391-45FF-B17D-DEEF178B3A19\"></a>To illustrate the behavior of nodes in the Dependency Graph, <span class=\"char_link\"><a href=\"#!/url=./files/GUID-10CE99A6-2C32-49E1-85ED-2E2F6782CF23.htm\">consider a simple mesh deformation node</a></span>. Such a node would take set of vertices as inputs, and transform them via its <span class=\"code\" translate=\"no\">compute()</span> function into a new set of output vertices. This new set of vertices can be subsequently\n\
               modified by another node in the dependency graph, and so on. \n\
            </p> \n\
            <div><a name=\"GUID-95CEB509-B01F-425D-AE95-876B9A458151\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"char_link\"><a href=\"#!/url=./files/GUID-0B85C721-C3C6-47D7-9D85-4F27B787ABB6.htm\">Directed Acyclic Graph (DAG), also known as the scene graph</a></span>, is a subset of the Dependency Graph. Transform and Shape nodes in the DAG can be\n\
                  connected to other nodes in the Dependency Graph to affect or animate their behavior.\n\
                  \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_FB5361C1A77B434FA2D1E27507379638\"></a> \n\
            <h2><a name=\"GUID-4A74A660-DA47-4651-B79A-6FAD1A6BB88F\"></a>Data Propagation and Node Computation\n\
            </h2> \n\
            <p><a name=\"GUID-A05BD06D-F3B0-4054-8C26-E7F4BFD36170\"></a>The purpose of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> is to flag values which need to be recomputed during Maya\'s ongoing Dependency Graph\n\
               evaluation process. If an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> is marked as <em class=\"mild\">dirty</em>, its associated value needs to be recomputed. This dirty flag propagates to the relevant\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>s in the graph. When a node containing a dirty <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> has its <span class=\"code\" translate=\"no\">compute()</span> function invoked, the dirty <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> is marked as <em class=\"mild\">clean</em> to avoid unnecessary recomputations. \n\
            </p> \n\
            <p><a name=\"GUID-6232E91A-080E-4BAD-AAB9-D13176AB511C\"></a>In the diagram below, the <span class=\"code\" translate=\"no\">compute()</span> function of the <span class=\"code\" translate=\"no\">mynode1</span> instance is being called to recompute the value associated with the \"<span class=\"code\" translate=\"no\">mynode1.outputAttribute</span>\" output <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>. The <span class=\"code\" translate=\"no\">compute()</span> function takes the following two parameters: \n\
            </p> <a name=\"OL_5330DACEF544437DA1D566E037B7E4CB\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">The \"dirty\" output MPlug -</em> A node may have multiple dirty output <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>s. This parameter informs us of which <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> we are \"cleaning\" with our computation. \n\
               </li>\n\
               <li><em class=\"strong\">An instance of MDataBlock -</em> The provided instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a></span> contains the input values needed to compute the output. The resulting output must\n\
                  be stored in the corresponding output <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span>, contained within the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a></span>. <span class=\"char_link\"><a href=\"#!/url=./files/GUID-AABB9BB4-816F-4C7C-A526-69B0568E1587.htm#SECTION_50DBB94939C64D659B9BACB40CF37CCA\">Later in this topic</a></span>, we explain how Maya <em class=\"mild\">knows</em> which inputs to provide to compute a specific output. \n\
               </li>\n\
            </ol> \n\
            <p><a name=\"GUID-40CFE3DA-DD30-4ECC-B312-261E08EA7079\"></a></p> <img src=\"images/GUID-6370D060-D685-44C2-B17F-CC2FB0546F8C-low.png\"> \n\
            <p><a name=\"GUID-B78195B4-B585-404A-A61D-F1FE6ED44268\"></a>As a brief example of data propagation and computation, suppose the user changes a\n\
               polygon\'s number of subdivisions via Maya\'s user interface. This will first cause\n\
               the immediately connected input <span class=\"code\" translate=\"no\">MPlugs</span> of the related shape node to be marked as \"dirty\". After this dirty flag has propagated\n\
               throughout the dependency graph, Maya will sequentially call <span class=\"code\" translate=\"no\">compute()</span> on the concerned nodes to \"clean\" the dirtied <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>s. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_50DBB94939C64D659B9BACB40CF37CCA\"></a> \n\
            <h2><a name=\"GUID-2E58CB08-F15F-438F-A350-D93A15C6824C\"></a>Defining a Custom Node\n\
            </h2> \n\
            <p><a name=\"GUID-E42CBAB5-94BA-41A1-A221-5DA874AAFECB\"></a>A custom node is defined by creating a Maya Dependency Graph plug-in. Such a plug-in\n\
               contains a class which inherits from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> or one of its subclasses. This new class will override the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.compute()</a></span> function to define the custom node\'s behavior. Once a Dependency Graph plug-in is\n\
               loaded into Maya, the Script Editor can be used to create an instance of the node.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-B9DBA075-D540-44C2-A001-14F9F51A5A3C\"></a></p> <img src=\"images/GUID-3E9CE733-0D7D-4C8C-8AEF-68DBE6B95F23-low.png\"> \n\
            <p><a name=\"GUID-93AC1D23-668C-4D4C-810B-1FA1BF4F5E7D\"></a>In the previous diagram, the <span class=\"code\" translate=\"no\">initializePlugin()</span> function makes a call to <span class=\"code\" translate=\"no\">mplugin.registerNode()</span>, passing the parameter \"<span class=\"code\" translate=\"no\">mynode</span>\" to declare the custom node type\'s name. An instance of this node can therefore be\n\
               created using the following Python script: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.createNode( \"mynode\" )</pre></div> \n\
            <p><a name=\"GUID-243C2891-E2DA-4A6B-8AB6-25E48C2307F4\"></a>The result is an instance of a node whose input and output <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>s are initialized according to the attributes declared in the plug-in (<span class=\"code\" translate=\"no\">nodeInitializer()</span>). More concretely, the attributes declared in the plug-in will dictate how the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>s will be created in terms of their type, default value, visibility in the UI, readability\n\
               (usable as input), writeability (usable as output), and whether or not the run-time\n\
               value should be stored to a file when the scene is saved. \n\
            </p> \n\
            <p><a name=\"GUID-DCCFE873-CC58-479F-AF44-05612D21C3A2\"></a>Observe that in the <span class=\"code\" translate=\"no\">nodeInitializer()</span> function of our plug-in definition, we declare an <em class=\"mild\">affects</em> relationship between: \n\
            </p> <a name=\"UL_9D2EF4C3360C4B2BA9F31F1642E2BD69\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">inputAttribute1</span> and <span class=\"code\" translate=\"no\">outputAttribute</span>, \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">inputAttribute2</span> and <span class=\"code\" translate=\"no\">outputAttribute</span>. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-DC350FB8-C0AA-4A21-8FBD-9CC5091B2AA8\"></a> The <em class=\"mild\">affects</em> relationship, declared using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.attributeAffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#adf19fe538d775ac2ec0169e6bc300f1c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.attributeAffects()</a></span>, tells Maya which inputs are required to compute a given output. As such, for any\n\
               given instance of our node, if the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> associated to its <span class=\"code\" translate=\"no\">inputAttribute1</span> is marked dirty, the dirty flag will also propagate to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> associated to its <span class=\"code\" translate=\"no\">outputAttribute</span>. This dirty flag propagation will therefore cause the node\'s <span class=\"code\" translate=\"no\">compute()</span> function to be called to clean the dirty <span class=\"code\" translate=\"no\">outputAttribute</span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";