var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-B1CD0989-EB49-46BE-934F-F23BFB869142\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using the Python API 2.0</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B1CD0989-EB49-46BE-934F-F23BFB869142\"></a><div class=\"head\">\n\
            <h1>Using the Python API 2.0</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0F347E5AF4A14C88835B5A6ADCE78BF4\"></a> \n\
            <h2><a name=\"GUID-F2134305-6A71-4DAD-AC5F-1B87D897664B\"></a>Using the Python API 2.0\n\
            </h2> \n\
            <p><a name=\"GUID-649DC164-05CE-4D3B-9D0A-5ABF2E88EEA7\"></a>The new Python API modules are found in <span class=\"code\" translate=\"no\">maya.api</span>. For example: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as om</pre></div> \n\
            <p><a name=\"GUID-E2F7914D-24A2-4B69-B8C8-D7688818C6E5\"></a>Module names are the same as in the old API with the exception that the proxy classes\n\
               (i.e. those beginning with <em class=\"mild\">MPx</em>) no longer have their own module but reside in the same modules as other related\n\
               classes. This more closely resembles the C++ API. \n\
            </p> \n\
            <p><a name=\"GUID-CEF82A1F-39C1-490B-858F-A986D4B4F1DE\"></a>Class names are the same as in the old Python API and the C++ API. Method names are\n\
               mostly the same with some differences where it affects the workflow. Some methods\n\
               which simply get or set values on an object have been replaced with Python object\n\
               attributes. \n\
            </p> \n\
            <p><a name=\"GUID-DD28EB3C-FA0F-4F53-8908-8A2C899791C9\"></a>New and old API classes can be used within the same script, but their objects are\n\
               not interchangeable. Thus, you can do this: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
newAttrFn = newOM.MFnAttribute(newAttrObj)\n\
oldNodeFn = oldOM.MFnDependencyNode(oldNodeObj)\n\
	\n\
# OKAY: Print names from old and new function sets.\n\
print(\"Attribute name is %s.%s\" % (oldNodeFn.name(), newAttrFn.name))</pre></div> \n\
            <p><a name=\"GUID-01A93C9A-9AA0-46B4-92A8-57B7813D12F6\"></a>but not this: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
# BAD: Passing an old API <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> to a new API method.\n\
newPlug = newOM.MPlug(oldNodeObj, newAttrObj)</pre></div> \n\
            <p><a name=\"GUID-2A3DF722-5F39-48C0-B01A-2431874D16DA\"></a>Given that the class and method names are mostly identical between the two APIs there\n\
               is a lot of potential for confusion so it\'s best not to mix them if you can avoid\n\
               it. \n\
            </p> \n\
            <p><a name=\"GUID-29D9CC9F-6FBF-451F-B7B7-4916E8695A2E\"></a>When writing a plugin which uses the new API, the plugin must define a function called\n\
               maya_useNewAPI so that Maya will know to pass it objects from the new API rather than\n\
               the old one. E.g: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def maya_useNewAPI():\n\
    pass</pre></div> \n\
            <p><a name=\"GUID-D2F59EE6-43B7-4D99-B88B-56F6590B9052\"></a>We encourage users to provide feedback on this new Python API through the online Suggestion\n\
               site available from the Maya Help Menu and through the Autodesk Developer Network.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-740929A4-1D24-4537-873F-1B47AB9A3C92\"></a>For information on the Python 2.0 Class list, consult the <a href=\"#!/url=./py_ref/index.html\">Maya Python API 2.0 Reference</a>. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";