var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-D5015546-E6E0-46F1-AAC2-D6635CDAA2D0\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Shader Driven Update</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D5015546-E6E0-46F1-AAC2-D6635CDAA2D0\"></a><div class=\"head\">\n\
            <h1>Shader Driven Update </h1>\n\
         </div>\n\
         <p><a name=\"GUID-47978957-3CD3-4020-812C-00D75CF7F4DD\"></a>The renderer is purely “shader based.” In other words, everything is rendered with\n\
            a shader and shader require­ments are the driving force to determine geometric data\n\
            requirements. Changes in geometric parameters may require data updates, but they are\n\
            with reference to the requirements of a shader. \n\
         </p>\n\
         <p><a name=\"GUID-5CFC3645-CEA1-4411-AD80-5CEEAA976F6A\"></a>When discussing “shaders,” these are not Maya shading networks but rather shaders\n\
            that the renderer supports internally. All internal shaders are <em class=\"strong\">programmable hardware shaders</em> and all recommended API interfaces also assume the usage of shaders. The concept\n\
            of <em class=\"strong\">fixed-function</em> rendering is no longer used nor exposed as a recom­mended method of drawing. \n\
         </p>\n\
         <p><a name=\"GUID-487A71BA-044F-43A8-B564-5376E2BE6B16\"></a>Each shader, whether used for drawing UI elements or for surface shading, specifies\n\
            a set of data requirements. Requirements from all shaders affecting a renderable object\n\
            are aggregated and used to inform the renderable object of the appropriate geometric\n\
            data it needs to provide. \n\
         </p>\n\
         <p><a name=\"GUID-4D393FDF-F66E-43DB-BF05-527DDC80323A\"></a>Both the shader specification and the geometric data may or may not be up-to-date.\n\
            The change management mechanism propagates change requirements to both as required.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-F7D07003-B0B6-4E39-A015-F27A4E373589\"></a>To illustrate this, a simplified scenario is shown: \n\
         </p><img src=\"images/GUID-1689D65F-EA43-4163-BB8F-D81DE29899F7-low.jpg\"><p><a name=\"GUID-E4F27FB0-E505-4C22-8415-75D2787D4604\"></a>Figure 4: Shows two shaders and a renderable object and their change (dirtying) dependencies\n\
            and data requirement dependencies. \n\
         </p>\n\
         <p><a name=\"GUID-D5640C13-3151-438A-A2A9-EFF53B6EF39D\"></a>The Maya constructs for the (top) shader and for the renderable object inform each,\n\
            respectively, of any changes. The renderer itself (“Render Options”) may also propagate\n\
            changes to both. A second (bottom) shader has no Maya object and could be used for\n\
            UI drawing for instance. It also specifies requirements. When an update is required,\n\
            all shaders provide requirements to the renderable object and the object fulfills\n\
            those requirements by updating the appropriate geometric data. \n\
         </p>\n\
         <p><a name=\"GUID-DAF4B7C3-BA9B-4F4E-AC88-ED3B8675FBC9\"></a>The end result of the update phase is newly created or updated render items. \n\
         </p>\n\
         <p><a name=\"GUID-7E314AFF-736A-4EB0-85BA-AD4618A44AC7\"></a>Each render item keeps track of both the shader as well as the data as a unit. Both\n\
            shaders and data can be shared across different render items. \n\
         </p><img src=\"images/GUID-673DB233-35B6-42CC-95FA-40268E5C7E75-low.jpg\"><p><a name=\"GUID-26796A91-EB68-4272-B460-7E0DBCCE6C4A\"></a>Figure 5: Data and shaders are independent of any individual render item and thus\n\
            can be shared across multiple render items. \n\
         </p>\n\
         <p><a name=\"GUID-E96AE2E6-3045-4A83-9787-1B2A640CDD11\"></a>A concrete, though slightly contrived example of the above scenario would be as follows:\n\
            \n\
         </p><a name=\"OL_37F13E642CD8409ABBA1A6CF29D2B153\"></a><ol type=\"1\" start=\"1\">\n\
            <li>A Maya object has been deformed. </li>\n\
            <li>The Maya shader assigned to the object requires bump mapping. </li>\n\
         </ol>\n\
         <p><a name=\"GUID-F13C89D4-EC83-447A-890C-DFE08DC4747D\"></a>The Maya object informs the renderable object of a change in geometry (topological\n\
            change). The Maya shading network informs its corresponding shader of a new shading\n\
            algorithm requirement, namely tangents and bitan­gents. The renderer informs the renderable\n\
            object of the requirement for a “UI” shader for drawing control points which requires\n\
            a second set of positions and color. The aggregate requirement would then be two sets\n\
            of positions and one set each of colors, normals, tangents and bitangents. \n\
         </p><a name=\"AA1000088\"></a><div class=\"table-not-ruled\">\n\
            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n\
               <colgroup>\n\
                  <col width=\"50%\">\n\
                  <col width=\"50%\">\n\
               </colgroup>\n\
               <tr class=\"not-ruled-odd-row\">\n\
                  <td class=\"table-body\"> <img src=\"images/GUID-94BED04E-BBE0-49F6-84F7-872D1FD3821C-low.jpg\"> <a name=\"GUID-ECB32FDC-9BE4-492E-BC98-AB49229C7651\"></a><p class=\"table-body\"> Figure 6: In this snapshot, a renderable is used to draw the filled torus with bump\n\
                        mapping. Another renderable is used to draw the control points. Though not mentioned\n\
                        in the sample scenario, a third is used to render the isoparms. \n\
                     </p> \n\
                  </td>\n\
                  <td class=\"table-body\"> <img src=\"images/GUID-73BE0F31-2967-43C4-B6ED-954A03ACB9DF-low.jpg\"> <a name=\"GUID-35F5AFFE-BD2B-46AE-AA47-D75FCD46A5B6\"></a><p class=\"table-body\">Figure 7: Render items which could be produced for the scenario. Positions (P1), normals,\n\
                        tangents and bitangents are referenced for the bump shader. A second set of positions\n\
                        (P2) and color are refer­enced for the control vertex shader. The isoparms render\n\
                        item is not shown. \n\
                     </p> \n\
                  </td>\n\
               </tr>\n\
            </table>\n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";