var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-F3D7C733-2850-468D-B6A8-EB51E3FD6F7B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Geometric Consolidation</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F3D7C733-2850-468D-B6A8-EB51E3FD6F7B\"></a><div class=\"head\">\n\
            <h1>Geometric Consolidation</h1>\n\
         </div>\n\
         <p><a name=\"GUID-D48592D9-983F-4473-AD85-56D23F10B074\"></a><em class=\"strong\">Geometric consolidation</em> is part of the rendering framework intended to improve performance. One of its main\n\
            purposes is to avoid what has been commonly called the <em class=\"strong\">small batch</em> problem in hardware rendering. The issue is that there is a certain amount of overhead\n\
            associated with each draw (per <em class=\"mild\">render item</em>). If the amount of overhead is large relative to the amount of geometry drawn, then\n\
            performance can degrade. \n\
         </p>\n\
         <p><a name=\"GUID-AC2CAB9C-3DF1-40E6-9711-680178E4FCCA\"></a>A render item, or <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span>, is a renderable primitive, something that is actually rendered on a graphics card.\n\
            For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-69E9D618-567A-42BD-BDDC-CD087BAA8934.htm\">Rendering Framework</a></span> and <span class=\"char_link\"><a href=\"#!/url=./files/GUID-C16CA3BB-5BCA-473F-9025-8676AB3EF914.htm\">Data Classes</a></span>. \n\
         </p>\n\
         <p><a name=\"GUID-0A97B2A1-E8F3-4B89-9C9F-74E50F09FC71\"></a>Consolidation, as the name implies, merges or “consolidates” render items with matching\n\
            geometric properties and shading algorithm. Ideally the result is fewer renderable\n\
            objects and reduced overhead cost. As an example, if one or more renderables want\n\
            to draw unshaded line segments, and each only had a few segments, then they could\n\
            be consolidated. \n\
         </p>\n\
         <p><a name=\"GUID-B8482729-2C15-43AE-9EFE-C9AD03D52C57\"></a>Thus, Maya DAG objects and components don’t necessarily have a 1:1 translation into\n\
            renderables. \n\
         </p>\n\
         <p><a name=\"GUID-3EDF2BA7-8924-4D14-AD76-A1B989CB55A3\"></a>Revisiting the previous pipeline diagram, we now have something which appears as follows:\n\
            \n\
         </p><img src=\"images/GUID-E6898B0F-78AE-4EAA-9BFB-22CC8EDAE70A-low.jpg\"><p><a name=\"GUID-5F46D59C-3C3A-4EF0-A2C7-2328494A6DC3\"></a>Figure 8: Example of two render items being merged into one after consolidation. \n\
         </p>\n\
         <p><a name=\"GUID-13A3D40F-3666-41F1-B33C-31A8E2A60724\"></a>After render items are determined, consolidation determines if they can be merged\n\
            to produce new consolidated render items. These new items are then drawn as appropriate.\n\
            \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";