var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-240D60CE-3FE3-4535-A208-690F719E8DC5\">\n\
      <meta name=\"indexterm\" content=\"shapes: selectable DAG objects, API\">\n\
      <meta name=\"indexterm\" content=\"DAG: objects, shapes, API\">\n\
      <meta name=\"indexterm\" content=\"shapes: user-defined, API\">\n\
      <meta name=\"indexterm\" content=\"shapes: shape node, writing\">\n\
      <meta name=\"indexterm\" content=\"MPxSurfaceShape\">\n\
      <meta name=\"indexterm\" content=\"shapes: MPxSurfaceShape, API\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Shapes in Maya</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-240D60CE-3FE3-4535-A208-690F719E8DC5\"></a><div class=\"head\">\n\
            <h1>Shapes in Maya</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F728\"></a> Shapes in Maya are selectable DAG objects that display in 3D views. Meshes, NURBS\n\
            surfaces and curves, and locators are just some examples of shapes. Shapes are also\n\
            dependency graph (DG) nodes that have attributes which can be connected to other nodes.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72A\"></a>Shapes can be thought of as a container for geometry. The role of this container is\n\
            to present the geometry for interactive display and manipulation.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72B\"></a>Shapes which are formed and manipulated by the position of control vertices (or CVs)\n\
            are called control point shapes. The control points are attributes on the shape which\n\
            are usually arrays of points. Control points become interactive, i.e. they can be\n\
            selected and manipulated, by associating the control point attributes with a component.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72C\"></a>Components are objects (MObject’s) which contain two pieces of information, the type\n\
            of component and the index values or range. For example, a mesh vertex component.\n\
            This component represents the vertex (or \"pnts\") attribute of a mesh shape, where\n\
            <span class=\"code\" translate=\"no\">vtx[0]</span> represents vertex 0 of the mesh and <span class=\"code\" translate=\"no\">vtx[0:7]</span> represents the first eight vertices of the mesh.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72D\"></a>Shapes which define a surface such as NURBS surfaces and meshes support hardware display\n\
            of materials and hardware lighting in interactive views as well as the hardware render\n\
            buffer. \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72E\"></a> \n\
            <h2><a name=\"GUID-9DBDBAFF-8AA4-430E-8B32-93F0B4ED45F2\"></a>User-defined shapes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F72F\"></a> The purpose of a user-defined shape and all the classes associated with shapes is\n\
               to \"wrap\" an arbitrary geometry type that you defined as a DAG node (and a DG node),\n\
               or as data passed through the DG.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F731\"></a>The class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span> lets you write shapes using the Maya API. Writing a shape node is similar to writing\n\
               a dependency node, in fact, the base class for user defined shapes (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span>) derives from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span>.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F732\"></a>  The major difference between <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> is the addition of component handling, drawing, and selection functions. The overridable\n\
               functions have been split into two classes, the DG node functionality is in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span> and the drawing and select functions are in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShapeUI</a></span>.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F735\"></a>User-defined shapes are best suited for control point based shapes such as polygonal\n\
               meshes or spline-based objects. This does not mean that you cannot write other kinds\n\
               of shapes, it just means that <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span> is already set up to handle control point based shapes.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F736\"></a>Shapes are registered using the <span class=\"code\" translate=\"no\">MFnPlugin::registersShape</span> function. This function is similar to registerNode but contains an additional argument\n\
               specifying the creator function for the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShapeUI</a></span> class. Unregistering shapes is done using <span class=\"code\" translate=\"no\">MFnPlugin::deregisterNode</span> in the same way that <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> classes are unregistered.\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";