var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-02-09\">\n\
      <meta name=\"topicid\" content=\"GUID-89EA0D0D-6178-4970-BBD6-6652764674EF\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Generic Attributes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-89EA0D0D-6178-4970-BBD6-6652764674EF\"></a><div class=\"head\">\n\
            <h1>Generic Attributes</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7EC\"></a>In this section of the Maya API documentation, we will describe parts of the Maya\n\
            API that are important but are not large enough for an entire chapter. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7EE\"></a>A generic attribute (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnGenericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_generic_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_generic_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnGenericAttribute</a></span>) is one that can accept several different types of data. A generic attribute is similar\n\
            to a typed attribute (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTypedAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTypedAttribute</a></span>) except that it has a list of types that it considers valid. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7EF\"></a>Generic attributes are useful for re-using the same attribute for multiple purposes.\n\
            For example, when writing a plug-in intersection node, an attribute will be used for\n\
            storing information regarding the object(s) that are being intersected. A plug-in\n\
            can create a generic attribute that can accept either a mesh or a surface for use\n\
            in the intersection calculation. If a generic attribute were not used, then the plug-in\n\
            would have to create two separate attributes: one for the mesh and one for the surface.\n\
            An additional advantage of generic attributes is that multiple nodes of the same type\n\
            can have their generic attribute type set independently. For example, in the intersection\n\
            example just described, you can create two nodes of the same type, with the generic\n\
            attribute of one set to a mesh and the other set to a surface. \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F0\"></a> \n\
            <h2><a name=\"GUID-F6B8186E-EFB8-4777-895D-9E40ED2555B6\"></a>Creation\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F1\"></a>Generic attributes for proxy plug-in nodes are created using the <span class=\"code\" translate=\"no\">initialize()</span> method of the plug-in. In addition to creating the attribute, the <span class=\"code\" translate=\"no\">initialize()</span> method will add the attribute to the node and state how this attribute can affect\n\
               or be affected by other attributes in the node. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F2\"></a>The following example, genericAttributeNode (available in the Developer Kit), demonstrates\n\
               how to create a generic attribute as an output: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
// Adds a generic attribute that accepts a float, float2, float3\n\
// Called from node initialization method.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> genericAttributeNode::addComplexFloatGenericAttribute( \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a>&amp; attrObject,\n\
    const char *longName, const char *shortName )\n\
{\n\
    // Create the generic attribute and set the 3 accepts types\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnGenericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_generic_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_generic_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnGenericAttribute</a> gAttr; \n\
    attrObject = gAttr.create( longName, shortName ); \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status = gAttr.addAccept(<a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::kFloat</a>); \n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    status = gAttr.addAccept(<a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::k2Float\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7af8f260603ef20b1e0c3d09de0e9c645c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::k2Float</a>); \n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    status = gAttr.addAccept(<a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::k3Float\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a91f4ea6e351f41893ac43d373f9d647c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::k3Float</a>); \n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    gAttr.setWritable(false);\n\
    gAttr.setStorable( false );\n\
\n\
    // Add the attribute to the node\n\
    status = addAttribute( attrObject );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    return MS::kSuccess;\n\
}\n\
\n\
// Node initialization method\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> genericAttributeNode::initialize()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a> nAttr;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status;\n\
    // single float attribute affecting a generic attribute\n\
    gInputInt = nAttr.create( \"gInputInt\", \"gii\",\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::kInt\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a9bb31be73c01d40428195449f62588ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::kInt</a>, 0, &amp;status );\n\
    nAttr.setStorable(true);\n\
    nAttr.setKeyable(true);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    status = addAttribute( gInputInt );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
    if ( !addComplexFloatGenericAttribute(\n\
        gOutputFloat_2Float_3Float,\n\
        \"gOutputFloat_2Float_3Float\", \"gof2f3f\" ) )\n\
        return MS::kFailure;\n\
    status = attributeAffects( \n\
        gInputInt, gOutputFloat_2Float_3Float );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( status );\n\
\n\
    return MS::kSuccess;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F3\"></a>In this example, an input attribute gInputInt affects a generic output attribute gOutputFloat_2Float_3Float.\n\
               The output attribute is capable of storing one of a float, float2 and float3 and this\n\
               is set by calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnGenericAttribute::addAccept()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_generic_attribute.html#a473c601e561d68fc3f6339f1ec017732&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnGenericAttribute::addAccept()</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F4\"></a> \n\
            <h2><a name=\"GUID-AEC4DFE2-4E13-4B64-AA36-74670E7533F4\"></a>Computing Generic Attributes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F5\"></a>Assuming that a plug-in’s generic attributes have been added correctly to a node,\n\
               they will be available for use in the node’s compute method. Within compute, generic\n\
               attribute information can be read and updated using standard Maya API calls. Additionally,\n\
               the type contained in a generic attribute can be modified. In our example below, the\n\
               generic attribute can store one of a float, float2 and float3. At compute time, the\n\
               float stored in this generic attribute can be converted to a float3. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
//\n\
// Compute that will update the generic attribute\n\
// when requested.\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> genericAttributeNode::compute( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a>&amp; data )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> returnStatus;\n\
    // Generic attribute plug\n\
    if ( plug == gOutputFloat_2Float_3Float )\n\
    {\n\
        // attribute affecting generic attribute case. Based on the\n\
        // input attribute, we modify the output generic attribute\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a> inputDataInt = data.inputValue( gInputInt );\n\
        int inputInt = inputDataInt.asInt();\n\
\n\
        // Get the output handle\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a> outputData = data.outputValue( plug );	\n\
        bool isGenericNumeric = false;\n\
        bool isGenericNull = false;\n\
        // Is the output handle generic data\n\
        if ( outputData.isGeneric( isGenericNumeric, isGenericNull ) )\n\
        {\n\
            // Based on the inputHandle, update the generic\n\
            // output handle\n\
            if ( inputInt == 1 )\n\
                outputData.setGenericBool( false, true );\n\
            else if ( inputInt == 2 )\n\
                outputData.setGenericBool( true, true );\n\
            else if ( inputInt == 3 )\n\
                outputData.setGenericChar( 254, true );\n\
            else if ( inputInt == 4 )\n\
                outputData.setGenericDouble( 3.145, true );\n\
            else if ( inputInt == 5 )\n\
                outputData.setGenericFloat( 9.98, true );	\n\
            else if ( inputInt == 6 )\n\
                outputData.setGenericShort( 3245, true );\n\
            else if ( inputInt == 7 )\n\
                outputData.setGenericInt( 32768, true );\n\
            else if ( inputInt == 8 )\n\
            {\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData</a> numericData;\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj = numericData.create(\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::k2Float\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7af8f260603ef20b1e0c3d09de0e9c645c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::k2Float</a>, &amp;returnStatus );\n\
                <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( returnStatus );\n\
                returnStatus = numericData.setData( \n\
                    (float)1.5, (float)6.7 );\n\
                <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( returnStatus );\n\
                outputData.set( obj );\n\
            }\n\
            else if ( inputInt == 9 )\n\
            {\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData</a> numericData;\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj = numericData.create(\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::k3Float\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a91f4ea6e351f41893ac43d373f9d647c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData::k3Float</a>, &amp;returnStatus );\n\
                <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( returnStaus );\n\
                returnStatus = numericData.setData( (float)2.5, (float)8.7, (float)2.3345 );\n\
                <a href=\"javascript:void(0)\" data-symbol=\"CHECK_MSTATUS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gae3dc78724237805e00a767b587b7cf79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">CHECK_MSTATUS</a>( returnStatus );\n\
                outputData.set( obj );\n\
            }\n\
            else if ( inputInt == 10 )\n\
            {\n\
                outputData.setGenericInt( 909, true );\n\
            }							\n\
            // Mark the data clean\n\
            outputData.setClean();\n\
            data.setClean( gOutputFloat_2Float_3Float );\n\
        }\n\
    } \n\
    else \n\
    {\n\
        return MS::kUnknownParameter;\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F6\"></a>In this example, we first obtain the value of the gInputInt attribute. This int value\n\
               will be used for setting the value and type of the generic output attribute gOutputFloat_2Float_3Float.\n\
               When the data handle is extracted from the data block for the generic attribute, the\n\
               <span class=\"code\" translate=\"no\">isGeneric()</span> method is called to ensure that the compute code is dealing with a generic attribute.\n\
               There are two parameters for the <span class=\"code\" translate=\"no\">isGeneric()</span> method. The first is <span class=\"code\" translate=\"no\">isNumeric</span> and a result of true signifies that the handle contains simple numeric information\n\
               such as char, float, etc. If <span class=\"code\" translate=\"no\">isNumeric</span> is false and <span class=\"code\" translate=\"no\">isNull</span> is not true, then the handle contains the more complex types of numerical information,\n\
               such as double2 or float2, as accessible through the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericData</a></span> function set. (The <span class=\"code\" translate=\"no\">isNumeric</span> and <span class=\"code\" translate=\"no\">isNull</span> parameters are not used in the code example above.) \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F7F7\"></a>It is not possible to distinguish the singleton generic types from one another. There\n\
               is no method that can be called to return the result of whether the singleton generic\n\
               attribute is a float, char or double, etc. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";